<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAnticipoNom ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAnticipoNom
 * @subpackage Arrays
 */
class ArrayOfAnticipoNom extends AbstractStructArrayBase
{
    /**
     * The AnticipoNom
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AnticipoNom[]
     */
    public $AnticipoNom;
    /**
     * Constructor method for ArrayOfAnticipoNom
     * @uses ArrayOfAnticipoNom::setAnticipoNom()
     * @param \StructType\AnticipoNom[] $anticipoNom
     */
    public function __construct(array $anticipoNom = array())
    {
        $this
            ->setAnticipoNom($anticipoNom);
    }
    /**
     * Get AnticipoNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AnticipoNom[]|null
     */
    public function getAnticipoNom()
    {
        return isset($this->AnticipoNom) ? $this->AnticipoNom : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAnticipoNom method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnticipoNom method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnticipoNomForArrayConstraintsFromSetAnticipoNom(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAnticipoNomAnticipoNomItem) {
            // validation for constraint: itemType
            if (!$arrayOfAnticipoNomAnticipoNomItem instanceof \StructType\AnticipoNom) {
                $invalidValues[] = is_object($arrayOfAnticipoNomAnticipoNomItem) ? get_class($arrayOfAnticipoNomAnticipoNomItem) : sprintf('%s(%s)', gettype($arrayOfAnticipoNomAnticipoNomItem), var_export($arrayOfAnticipoNomAnticipoNomItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AnticipoNom property can only contain items of type \StructType\AnticipoNom, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AnticipoNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AnticipoNom[] $anticipoNom
     * @return \ArrayType\ArrayOfAnticipoNom
     */
    public function setAnticipoNom(array $anticipoNom = array())
    {
        // validation for constraint: array
        if ('' !== ($anticipoNomArrayErrorMessage = self::validateAnticipoNomForArrayConstraintsFromSetAnticipoNom($anticipoNom))) {
            throw new \InvalidArgumentException($anticipoNomArrayErrorMessage, __LINE__);
        }
        if (is_null($anticipoNom) || (is_array($anticipoNom) && empty($anticipoNom))) {
            unset($this->AnticipoNom);
        } else {
            $this->AnticipoNom = $anticipoNom;
        }
        return $this;
    }
    /**
     * Add item to AnticipoNom value
     * @throws \InvalidArgumentException
     * @param \StructType\AnticipoNom $item
     * @return \ArrayType\ArrayOfAnticipoNom
     */
    public function addToAnticipoNom(\StructType\AnticipoNom $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnticipoNom) {
            throw new \InvalidArgumentException(sprintf('The AnticipoNom property can only contain items of type \StructType\AnticipoNom, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AnticipoNom[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AnticipoNom|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AnticipoNom|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AnticipoNom|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AnticipoNom|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AnticipoNom|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AnticipoNom
     */
    public function getAttributeName()
    {
        return 'AnticipoNom';
    }
}
