<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAuxilio ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAuxilio
 * @subpackage Arrays
 */
class ArrayOfAuxilio extends AbstractStructArrayBase
{
    /**
     * The Auxilio
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Auxilio[]
     */
    public $Auxilio;
    /**
     * Constructor method for ArrayOfAuxilio
     * @uses ArrayOfAuxilio::setAuxilio()
     * @param \StructType\Auxilio[] $auxilio
     */
    public function __construct(array $auxilio = array())
    {
        $this
            ->setAuxilio($auxilio);
    }
    /**
     * Get Auxilio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Auxilio[]|null
     */
    public function getAuxilio()
    {
        return isset($this->Auxilio) ? $this->Auxilio : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAuxilio method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAuxilio method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAuxilioForArrayConstraintsFromSetAuxilio(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAuxilioAuxilioItem) {
            // validation for constraint: itemType
            if (!$arrayOfAuxilioAuxilioItem instanceof \StructType\Auxilio) {
                $invalidValues[] = is_object($arrayOfAuxilioAuxilioItem) ? get_class($arrayOfAuxilioAuxilioItem) : sprintf('%s(%s)', gettype($arrayOfAuxilioAuxilioItem), var_export($arrayOfAuxilioAuxilioItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Auxilio property can only contain items of type \StructType\Auxilio, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Auxilio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Auxilio[] $auxilio
     * @return \ArrayType\ArrayOfAuxilio
     */
    public function setAuxilio(array $auxilio = array())
    {
        // validation for constraint: array
        if ('' !== ($auxilioArrayErrorMessage = self::validateAuxilioForArrayConstraintsFromSetAuxilio($auxilio))) {
            throw new \InvalidArgumentException($auxilioArrayErrorMessage, __LINE__);
        }
        if (is_null($auxilio) || (is_array($auxilio) && empty($auxilio))) {
            unset($this->Auxilio);
        } else {
            $this->Auxilio = $auxilio;
        }
        return $this;
    }
    /**
     * Add item to Auxilio value
     * @throws \InvalidArgumentException
     * @param \StructType\Auxilio $item
     * @return \ArrayType\ArrayOfAuxilio
     */
    public function addToAuxilio(\StructType\Auxilio $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Auxilio) {
            throw new \InvalidArgumentException(sprintf('The Auxilio property can only contain items of type \StructType\Auxilio, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Auxilio[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Auxilio|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Auxilio|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Auxilio|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Auxilio|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Auxilio|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Auxilio
     */
    public function getAttributeName()
    {
        return 'Auxilio';
    }
}
