<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBonificacion ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBonificacion
 * @subpackage Arrays
 */
class ArrayOfBonificacion extends AbstractStructArrayBase
{
    /**
     * The Bonificacion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Bonificacion[]
     */
    public $Bonificacion;
    /**
     * Constructor method for ArrayOfBonificacion
     * @uses ArrayOfBonificacion::setBonificacion()
     * @param \StructType\Bonificacion[] $bonificacion
     */
    public function __construct(array $bonificacion = array())
    {
        $this
            ->setBonificacion($bonificacion);
    }
    /**
     * Get Bonificacion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Bonificacion[]|null
     */
    public function getBonificacion()
    {
        return isset($this->Bonificacion) ? $this->Bonificacion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBonificacion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBonificacion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBonificacionForArrayConstraintsFromSetBonificacion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBonificacionBonificacionItem) {
            // validation for constraint: itemType
            if (!$arrayOfBonificacionBonificacionItem instanceof \StructType\Bonificacion) {
                $invalidValues[] = is_object($arrayOfBonificacionBonificacionItem) ? get_class($arrayOfBonificacionBonificacionItem) : sprintf('%s(%s)', gettype($arrayOfBonificacionBonificacionItem), var_export($arrayOfBonificacionBonificacionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Bonificacion property can only contain items of type \StructType\Bonificacion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Bonificacion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Bonificacion[] $bonificacion
     * @return \ArrayType\ArrayOfBonificacion
     */
    public function setBonificacion(array $bonificacion = array())
    {
        // validation for constraint: array
        if ('' !== ($bonificacionArrayErrorMessage = self::validateBonificacionForArrayConstraintsFromSetBonificacion($bonificacion))) {
            throw new \InvalidArgumentException($bonificacionArrayErrorMessage, __LINE__);
        }
        if (is_null($bonificacion) || (is_array($bonificacion) && empty($bonificacion))) {
            unset($this->Bonificacion);
        } else {
            $this->Bonificacion = $bonificacion;
        }
        return $this;
    }
    /**
     * Add item to Bonificacion value
     * @throws \InvalidArgumentException
     * @param \StructType\Bonificacion $item
     * @return \ArrayType\ArrayOfBonificacion
     */
    public function addToBonificacion(\StructType\Bonificacion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Bonificacion) {
            throw new \InvalidArgumentException(sprintf('The Bonificacion property can only contain items of type \StructType\Bonificacion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Bonificacion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Bonificacion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Bonificacion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Bonificacion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Bonificacion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Bonificacion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Bonificacion
     */
    public function getAttributeName()
    {
        return 'Bonificacion';
    }
}
