<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBonoEPCTV ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBonoEPCTV
 * @subpackage Arrays
 */
class ArrayOfBonoEPCTV extends AbstractStructArrayBase
{
    /**
     * The BonoEPCTV
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BonoEPCTV[]
     */
    public $BonoEPCTV;
    /**
     * Constructor method for ArrayOfBonoEPCTV
     * @uses ArrayOfBonoEPCTV::setBonoEPCTV()
     * @param \StructType\BonoEPCTV[] $bonoEPCTV
     */
    public function __construct(array $bonoEPCTV = array())
    {
        $this
            ->setBonoEPCTV($bonoEPCTV);
    }
    /**
     * Get BonoEPCTV value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BonoEPCTV[]|null
     */
    public function getBonoEPCTV()
    {
        return isset($this->BonoEPCTV) ? $this->BonoEPCTV : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBonoEPCTV method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBonoEPCTV method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBonoEPCTVForArrayConstraintsFromSetBonoEPCTV(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBonoEPCTVBonoEPCTVItem) {
            // validation for constraint: itemType
            if (!$arrayOfBonoEPCTVBonoEPCTVItem instanceof \StructType\BonoEPCTV) {
                $invalidValues[] = is_object($arrayOfBonoEPCTVBonoEPCTVItem) ? get_class($arrayOfBonoEPCTVBonoEPCTVItem) : sprintf('%s(%s)', gettype($arrayOfBonoEPCTVBonoEPCTVItem), var_export($arrayOfBonoEPCTVBonoEPCTVItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BonoEPCTV property can only contain items of type \StructType\BonoEPCTV, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BonoEPCTV value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BonoEPCTV[] $bonoEPCTV
     * @return \ArrayType\ArrayOfBonoEPCTV
     */
    public function setBonoEPCTV(array $bonoEPCTV = array())
    {
        // validation for constraint: array
        if ('' !== ($bonoEPCTVArrayErrorMessage = self::validateBonoEPCTVForArrayConstraintsFromSetBonoEPCTV($bonoEPCTV))) {
            throw new \InvalidArgumentException($bonoEPCTVArrayErrorMessage, __LINE__);
        }
        if (is_null($bonoEPCTV) || (is_array($bonoEPCTV) && empty($bonoEPCTV))) {
            unset($this->BonoEPCTV);
        } else {
            $this->BonoEPCTV = $bonoEPCTV;
        }
        return $this;
    }
    /**
     * Add item to BonoEPCTV value
     * @throws \InvalidArgumentException
     * @param \StructType\BonoEPCTV $item
     * @return \ArrayType\ArrayOfBonoEPCTV
     */
    public function addToBonoEPCTV(\StructType\BonoEPCTV $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BonoEPCTV) {
            throw new \InvalidArgumentException(sprintf('The BonoEPCTV property can only contain items of type \StructType\BonoEPCTV, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BonoEPCTV[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BonoEPCTV|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BonoEPCTV|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BonoEPCTV|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BonoEPCTV|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BonoEPCTV|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BonoEPCTV
     */
    public function getAttributeName()
    {
        return 'BonoEPCTV';
    }
}
