<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCesantia ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCesantia
 * @subpackage Arrays
 */
class ArrayOfCesantia extends AbstractStructArrayBase
{
    /**
     * The Cesantia
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Cesantia[]
     */
    public $Cesantia;
    /**
     * Constructor method for ArrayOfCesantia
     * @uses ArrayOfCesantia::setCesantia()
     * @param \StructType\Cesantia[] $cesantia
     */
    public function __construct(array $cesantia = array())
    {
        $this
            ->setCesantia($cesantia);
    }
    /**
     * Get Cesantia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Cesantia[]|null
     */
    public function getCesantia()
    {
        return isset($this->Cesantia) ? $this->Cesantia : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCesantia method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCesantia method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCesantiaForArrayConstraintsFromSetCesantia(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCesantiaCesantiaItem) {
            // validation for constraint: itemType
            if (!$arrayOfCesantiaCesantiaItem instanceof \StructType\Cesantia) {
                $invalidValues[] = is_object($arrayOfCesantiaCesantiaItem) ? get_class($arrayOfCesantiaCesantiaItem) : sprintf('%s(%s)', gettype($arrayOfCesantiaCesantiaItem), var_export($arrayOfCesantiaCesantiaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Cesantia property can only contain items of type \StructType\Cesantia, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Cesantia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Cesantia[] $cesantia
     * @return \ArrayType\ArrayOfCesantia
     */
    public function setCesantia(array $cesantia = array())
    {
        // validation for constraint: array
        if ('' !== ($cesantiaArrayErrorMessage = self::validateCesantiaForArrayConstraintsFromSetCesantia($cesantia))) {
            throw new \InvalidArgumentException($cesantiaArrayErrorMessage, __LINE__);
        }
        if (is_null($cesantia) || (is_array($cesantia) && empty($cesantia))) {
            unset($this->Cesantia);
        } else {
            $this->Cesantia = $cesantia;
        }
        return $this;
    }
    /**
     * Add item to Cesantia value
     * @throws \InvalidArgumentException
     * @param \StructType\Cesantia $item
     * @return \ArrayType\ArrayOfCesantia
     */
    public function addToCesantia(\StructType\Cesantia $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Cesantia) {
            throw new \InvalidArgumentException(sprintf('The Cesantia property can only contain items of type \StructType\Cesantia, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Cesantia[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Cesantia|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Cesantia|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Cesantia|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Cesantia|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Cesantia|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Cesantia
     */
    public function getAttributeName()
    {
        return 'Cesantia';
    }
}
