<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCompensacion ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCompensacion
 * @subpackage Arrays
 */
class ArrayOfCompensacion extends AbstractStructArrayBase
{
    /**
     * The Compensacion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Compensacion[]
     */
    public $Compensacion;
    /**
     * Constructor method for ArrayOfCompensacion
     * @uses ArrayOfCompensacion::setCompensacion()
     * @param \StructType\Compensacion[] $compensacion
     */
    public function __construct(array $compensacion = array())
    {
        $this
            ->setCompensacion($compensacion);
    }
    /**
     * Get Compensacion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Compensacion[]|null
     */
    public function getCompensacion()
    {
        return isset($this->Compensacion) ? $this->Compensacion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCompensacion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCompensacion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCompensacionForArrayConstraintsFromSetCompensacion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCompensacionCompensacionItem) {
            // validation for constraint: itemType
            if (!$arrayOfCompensacionCompensacionItem instanceof \StructType\Compensacion) {
                $invalidValues[] = is_object($arrayOfCompensacionCompensacionItem) ? get_class($arrayOfCompensacionCompensacionItem) : sprintf('%s(%s)', gettype($arrayOfCompensacionCompensacionItem), var_export($arrayOfCompensacionCompensacionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Compensacion property can only contain items of type \StructType\Compensacion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Compensacion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Compensacion[] $compensacion
     * @return \ArrayType\ArrayOfCompensacion
     */
    public function setCompensacion(array $compensacion = array())
    {
        // validation for constraint: array
        if ('' !== ($compensacionArrayErrorMessage = self::validateCompensacionForArrayConstraintsFromSetCompensacion($compensacion))) {
            throw new \InvalidArgumentException($compensacionArrayErrorMessage, __LINE__);
        }
        if (is_null($compensacion) || (is_array($compensacion) && empty($compensacion))) {
            unset($this->Compensacion);
        } else {
            $this->Compensacion = $compensacion;
        }
        return $this;
    }
    /**
     * Add item to Compensacion value
     * @throws \InvalidArgumentException
     * @param \StructType\Compensacion $item
     * @return \ArrayType\ArrayOfCompensacion
     */
    public function addToCompensacion(\StructType\Compensacion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Compensacion) {
            throw new \InvalidArgumentException(sprintf('The Compensacion property can only contain items of type \StructType\Compensacion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Compensacion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Compensacion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Compensacion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Compensacion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Compensacion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Compensacion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Compensacion
     */
    public function getAttributeName()
    {
        return 'Compensacion';
    }
}
