<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentoReferenciadoNom ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentoReferenciadoNom
 * @subpackage Arrays
 */
class ArrayOfDocumentoReferenciadoNom extends AbstractStructArrayBase
{
    /**
     * The DocumentoReferenciadoNom
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentoReferenciadoNom[]
     */
    public $DocumentoReferenciadoNom;
    /**
     * Constructor method for ArrayOfDocumentoReferenciadoNom
     * @uses ArrayOfDocumentoReferenciadoNom::setDocumentoReferenciadoNom()
     * @param \StructType\DocumentoReferenciadoNom[] $documentoReferenciadoNom
     */
    public function __construct(array $documentoReferenciadoNom = array())
    {
        $this
            ->setDocumentoReferenciadoNom($documentoReferenciadoNom);
    }
    /**
     * Get DocumentoReferenciadoNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentoReferenciadoNom[]|null
     */
    public function getDocumentoReferenciadoNom()
    {
        return isset($this->DocumentoReferenciadoNom) ? $this->DocumentoReferenciadoNom : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDocumentoReferenciadoNom method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocumentoReferenciadoNom method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentoReferenciadoNomForArrayConstraintsFromSetDocumentoReferenciadoNom(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDocumentoReferenciadoNomDocumentoReferenciadoNomItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentoReferenciadoNomDocumentoReferenciadoNomItem instanceof \StructType\DocumentoReferenciadoNom) {
                $invalidValues[] = is_object($arrayOfDocumentoReferenciadoNomDocumentoReferenciadoNomItem) ? get_class($arrayOfDocumentoReferenciadoNomDocumentoReferenciadoNomItem) : sprintf('%s(%s)', gettype($arrayOfDocumentoReferenciadoNomDocumentoReferenciadoNomItem), var_export($arrayOfDocumentoReferenciadoNomDocumentoReferenciadoNomItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DocumentoReferenciadoNom property can only contain items of type \StructType\DocumentoReferenciadoNom, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DocumentoReferenciadoNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentoReferenciadoNom[] $documentoReferenciadoNom
     * @return \ArrayType\ArrayOfDocumentoReferenciadoNom
     */
    public function setDocumentoReferenciadoNom(array $documentoReferenciadoNom = array())
    {
        // validation for constraint: array
        if ('' !== ($documentoReferenciadoNomArrayErrorMessage = self::validateDocumentoReferenciadoNomForArrayConstraintsFromSetDocumentoReferenciadoNom($documentoReferenciadoNom))) {
            throw new \InvalidArgumentException($documentoReferenciadoNomArrayErrorMessage, __LINE__);
        }
        if (is_null($documentoReferenciadoNom) || (is_array($documentoReferenciadoNom) && empty($documentoReferenciadoNom))) {
            unset($this->DocumentoReferenciadoNom);
        } else {
            $this->DocumentoReferenciadoNom = $documentoReferenciadoNom;
        }
        return $this;
    }
    /**
     * Add item to DocumentoReferenciadoNom value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentoReferenciadoNom $item
     * @return \ArrayType\ArrayOfDocumentoReferenciadoNom
     */
    public function addToDocumentoReferenciadoNom(\StructType\DocumentoReferenciadoNom $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentoReferenciadoNom) {
            throw new \InvalidArgumentException(sprintf('The DocumentoReferenciadoNom property can only contain items of type \StructType\DocumentoReferenciadoNom, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DocumentoReferenciadoNom[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentoReferenciadoNom|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentoReferenciadoNom|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentoReferenciadoNom|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentoReferenciadoNom|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentoReferenciadoNom|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentoReferenciadoNom
     */
    public function getAttributeName()
    {
        return 'DocumentoReferenciadoNom';
    }
}
