<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExtensibleNom ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfExtensibleNom
 * @subpackage Arrays
 */
class ArrayOfExtensibleNom extends AbstractStructArrayBase
{
    /**
     * The ExtensibleNom
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ExtensibleNom[]
     */
    public $ExtensibleNom;
    /**
     * Constructor method for ArrayOfExtensibleNom
     * @uses ArrayOfExtensibleNom::setExtensibleNom()
     * @param \StructType\ExtensibleNom[] $extensibleNom
     */
    public function __construct(array $extensibleNom = array())
    {
        $this
            ->setExtensibleNom($extensibleNom);
    }
    /**
     * Get ExtensibleNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ExtensibleNom[]|null
     */
    public function getExtensibleNom()
    {
        return isset($this->ExtensibleNom) ? $this->ExtensibleNom : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExtensibleNom method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExtensibleNom method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExtensibleNomForArrayConstraintsFromSetExtensibleNom(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExtensibleNomExtensibleNomItem) {
            // validation for constraint: itemType
            if (!$arrayOfExtensibleNomExtensibleNomItem instanceof \StructType\ExtensibleNom) {
                $invalidValues[] = is_object($arrayOfExtensibleNomExtensibleNomItem) ? get_class($arrayOfExtensibleNomExtensibleNomItem) : sprintf('%s(%s)', gettype($arrayOfExtensibleNomExtensibleNomItem), var_export($arrayOfExtensibleNomExtensibleNomItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExtensibleNom property can only contain items of type \StructType\ExtensibleNom, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExtensibleNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ExtensibleNom[] $extensibleNom
     * @return \ArrayType\ArrayOfExtensibleNom
     */
    public function setExtensibleNom(array $extensibleNom = array())
    {
        // validation for constraint: array
        if ('' !== ($extensibleNomArrayErrorMessage = self::validateExtensibleNomForArrayConstraintsFromSetExtensibleNom($extensibleNom))) {
            throw new \InvalidArgumentException($extensibleNomArrayErrorMessage, __LINE__);
        }
        if (is_null($extensibleNom) || (is_array($extensibleNom) && empty($extensibleNom))) {
            unset($this->ExtensibleNom);
        } else {
            $this->ExtensibleNom = $extensibleNom;
        }
        return $this;
    }
    /**
     * Add item to ExtensibleNom value
     * @throws \InvalidArgumentException
     * @param \StructType\ExtensibleNom $item
     * @return \ArrayType\ArrayOfExtensibleNom
     */
    public function addToExtensibleNom(\StructType\ExtensibleNom $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExtensibleNom) {
            throw new \InvalidArgumentException(sprintf('The ExtensibleNom property can only contain items of type \StructType\ExtensibleNom, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExtensibleNom[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ExtensibleNom|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ExtensibleNom|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ExtensibleNom|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ExtensibleNom|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ExtensibleNom|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExtensibleNom
     */
    public function getAttributeName()
    {
        return 'ExtensibleNom';
    }
}
