<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFechaPago ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFechaPago
 * @subpackage Arrays
 */
class ArrayOfFechaPago extends AbstractStructArrayBase
{
    /**
     * The FechaPago
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FechaPago[]
     */
    public $FechaPago;
    /**
     * Constructor method for ArrayOfFechaPago
     * @uses ArrayOfFechaPago::setFechaPago()
     * @param \StructType\FechaPago[] $fechaPago
     */
    public function __construct(array $fechaPago = array())
    {
        $this
            ->setFechaPago($fechaPago);
    }
    /**
     * Get FechaPago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FechaPago[]|null
     */
    public function getFechaPago()
    {
        return isset($this->FechaPago) ? $this->FechaPago : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFechaPago method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFechaPago method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFechaPagoForArrayConstraintsFromSetFechaPago(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFechaPagoFechaPagoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFechaPagoFechaPagoItem instanceof \StructType\FechaPago) {
                $invalidValues[] = is_object($arrayOfFechaPagoFechaPagoItem) ? get_class($arrayOfFechaPagoFechaPagoItem) : sprintf('%s(%s)', gettype($arrayOfFechaPagoFechaPagoItem), var_export($arrayOfFechaPagoFechaPagoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FechaPago property can only contain items of type \StructType\FechaPago, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FechaPago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FechaPago[] $fechaPago
     * @return \ArrayType\ArrayOfFechaPago
     */
    public function setFechaPago(array $fechaPago = array())
    {
        // validation for constraint: array
        if ('' !== ($fechaPagoArrayErrorMessage = self::validateFechaPagoForArrayConstraintsFromSetFechaPago($fechaPago))) {
            throw new \InvalidArgumentException($fechaPagoArrayErrorMessage, __LINE__);
        }
        if (is_null($fechaPago) || (is_array($fechaPago) && empty($fechaPago))) {
            unset($this->FechaPago);
        } else {
            $this->FechaPago = $fechaPago;
        }
        return $this;
    }
    /**
     * Add item to FechaPago value
     * @throws \InvalidArgumentException
     * @param \StructType\FechaPago $item
     * @return \ArrayType\ArrayOfFechaPago
     */
    public function addToFechaPago(\StructType\FechaPago $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FechaPago) {
            throw new \InvalidArgumentException(sprintf('The FechaPago property can only contain items of type \StructType\FechaPago, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FechaPago[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FechaPago|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FechaPago|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FechaPago|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FechaPago|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FechaPago|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FechaPago
     */
    public function getAttributeName()
    {
        return 'FechaPago';
    }
}
