<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFondoPension ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFondoPension
 * @subpackage Arrays
 */
class ArrayOfFondoPension extends AbstractStructArrayBase
{
    /**
     * The FondoPension
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FondoPension[]
     */
    public $FondoPension;
    /**
     * Constructor method for ArrayOfFondoPension
     * @uses ArrayOfFondoPension::setFondoPension()
     * @param \StructType\FondoPension[] $fondoPension
     */
    public function __construct(array $fondoPension = array())
    {
        $this
            ->setFondoPension($fondoPension);
    }
    /**
     * Get FondoPension value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FondoPension[]|null
     */
    public function getFondoPension()
    {
        return isset($this->FondoPension) ? $this->FondoPension : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFondoPension method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFondoPension method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFondoPensionForArrayConstraintsFromSetFondoPension(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFondoPensionFondoPensionItem) {
            // validation for constraint: itemType
            if (!$arrayOfFondoPensionFondoPensionItem instanceof \StructType\FondoPension) {
                $invalidValues[] = is_object($arrayOfFondoPensionFondoPensionItem) ? get_class($arrayOfFondoPensionFondoPensionItem) : sprintf('%s(%s)', gettype($arrayOfFondoPensionFondoPensionItem), var_export($arrayOfFondoPensionFondoPensionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FondoPension property can only contain items of type \StructType\FondoPension, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FondoPension value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FondoPension[] $fondoPension
     * @return \ArrayType\ArrayOfFondoPension
     */
    public function setFondoPension(array $fondoPension = array())
    {
        // validation for constraint: array
        if ('' !== ($fondoPensionArrayErrorMessage = self::validateFondoPensionForArrayConstraintsFromSetFondoPension($fondoPension))) {
            throw new \InvalidArgumentException($fondoPensionArrayErrorMessage, __LINE__);
        }
        if (is_null($fondoPension) || (is_array($fondoPension) && empty($fondoPension))) {
            unset($this->FondoPension);
        } else {
            $this->FondoPension = $fondoPension;
        }
        return $this;
    }
    /**
     * Add item to FondoPension value
     * @throws \InvalidArgumentException
     * @param \StructType\FondoPension $item
     * @return \ArrayType\ArrayOfFondoPension
     */
    public function addToFondoPension(\StructType\FondoPension $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FondoPension) {
            throw new \InvalidArgumentException(sprintf('The FondoPension property can only contain items of type \StructType\FondoPension, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FondoPension[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FondoPension|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FondoPension|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FondoPension|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FondoPension|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FondoPension|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FondoPension
     */
    public function getAttributeName()
    {
        return 'FondoPension';
    }
}
