<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFondoSP ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFondoSP
 * @subpackage Arrays
 */
class ArrayOfFondoSP extends AbstractStructArrayBase
{
    /**
     * The FondoSP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FondoSP[]
     */
    public $FondoSP;
    /**
     * Constructor method for ArrayOfFondoSP
     * @uses ArrayOfFondoSP::setFondoSP()
     * @param \StructType\FondoSP[] $fondoSP
     */
    public function __construct(array $fondoSP = array())
    {
        $this
            ->setFondoSP($fondoSP);
    }
    /**
     * Get FondoSP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FondoSP[]|null
     */
    public function getFondoSP()
    {
        return isset($this->FondoSP) ? $this->FondoSP : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFondoSP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFondoSP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFondoSPForArrayConstraintsFromSetFondoSP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFondoSPFondoSPItem) {
            // validation for constraint: itemType
            if (!$arrayOfFondoSPFondoSPItem instanceof \StructType\FondoSP) {
                $invalidValues[] = is_object($arrayOfFondoSPFondoSPItem) ? get_class($arrayOfFondoSPFondoSPItem) : sprintf('%s(%s)', gettype($arrayOfFondoSPFondoSPItem), var_export($arrayOfFondoSPFondoSPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FondoSP property can only contain items of type \StructType\FondoSP, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FondoSP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FondoSP[] $fondoSP
     * @return \ArrayType\ArrayOfFondoSP
     */
    public function setFondoSP(array $fondoSP = array())
    {
        // validation for constraint: array
        if ('' !== ($fondoSPArrayErrorMessage = self::validateFondoSPForArrayConstraintsFromSetFondoSP($fondoSP))) {
            throw new \InvalidArgumentException($fondoSPArrayErrorMessage, __LINE__);
        }
        if (is_null($fondoSP) || (is_array($fondoSP) && empty($fondoSP))) {
            unset($this->FondoSP);
        } else {
            $this->FondoSP = $fondoSP;
        }
        return $this;
    }
    /**
     * Add item to FondoSP value
     * @throws \InvalidArgumentException
     * @param \StructType\FondoSP $item
     * @return \ArrayType\ArrayOfFondoSP
     */
    public function addToFondoSP(\StructType\FondoSP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FondoSP) {
            throw new \InvalidArgumentException(sprintf('The FondoSP property can only contain items of type \StructType\FondoSP, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FondoSP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FondoSP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FondoSP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FondoSP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FondoSP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FondoSP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FondoSP
     */
    public function getAttributeName()
    {
        return 'FondoSP';
    }
}
