<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHoraExtra ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHoraExtra
 * @subpackage Arrays
 */
class ArrayOfHoraExtra extends AbstractStructArrayBase
{
    /**
     * The HoraExtra
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HoraExtra[]
     */
    public $HoraExtra;
    /**
     * Constructor method for ArrayOfHoraExtra
     * @uses ArrayOfHoraExtra::setHoraExtra()
     * @param \StructType\HoraExtra[] $horaExtra
     */
    public function __construct(array $horaExtra = array())
    {
        $this
            ->setHoraExtra($horaExtra);
    }
    /**
     * Get HoraExtra value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HoraExtra[]|null
     */
    public function getHoraExtra()
    {
        return isset($this->HoraExtra) ? $this->HoraExtra : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHoraExtra method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHoraExtra method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHoraExtraForArrayConstraintsFromSetHoraExtra(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHoraExtraHoraExtraItem) {
            // validation for constraint: itemType
            if (!$arrayOfHoraExtraHoraExtraItem instanceof \StructType\HoraExtra) {
                $invalidValues[] = is_object($arrayOfHoraExtraHoraExtraItem) ? get_class($arrayOfHoraExtraHoraExtraItem) : sprintf('%s(%s)', gettype($arrayOfHoraExtraHoraExtraItem), var_export($arrayOfHoraExtraHoraExtraItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HoraExtra property can only contain items of type \StructType\HoraExtra, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HoraExtra value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HoraExtra[] $horaExtra
     * @return \ArrayType\ArrayOfHoraExtra
     */
    public function setHoraExtra(array $horaExtra = array())
    {
        // validation for constraint: array
        if ('' !== ($horaExtraArrayErrorMessage = self::validateHoraExtraForArrayConstraintsFromSetHoraExtra($horaExtra))) {
            throw new \InvalidArgumentException($horaExtraArrayErrorMessage, __LINE__);
        }
        if (is_null($horaExtra) || (is_array($horaExtra) && empty($horaExtra))) {
            unset($this->HoraExtra);
        } else {
            $this->HoraExtra = $horaExtra;
        }
        return $this;
    }
    /**
     * Add item to HoraExtra value
     * @throws \InvalidArgumentException
     * @param \StructType\HoraExtra $item
     * @return \ArrayType\ArrayOfHoraExtra
     */
    public function addToHoraExtra(\StructType\HoraExtra $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HoraExtra) {
            throw new \InvalidArgumentException(sprintf('The HoraExtra property can only contain items of type \StructType\HoraExtra, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HoraExtra[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HoraExtra|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HoraExtra|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HoraExtra|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HoraExtra|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HoraExtra|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HoraExtra
     */
    public function getAttributeName()
    {
        return 'HoraExtra';
    }
}
