<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIncapacidad ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfIncapacidad
 * @subpackage Arrays
 */
class ArrayOfIncapacidad extends AbstractStructArrayBase
{
    /**
     * The Incapacidad
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Incapacidad[]
     */
    public $Incapacidad;
    /**
     * Constructor method for ArrayOfIncapacidad
     * @uses ArrayOfIncapacidad::setIncapacidad()
     * @param \StructType\Incapacidad[] $incapacidad
     */
    public function __construct(array $incapacidad = array())
    {
        $this
            ->setIncapacidad($incapacidad);
    }
    /**
     * Get Incapacidad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Incapacidad[]|null
     */
    public function getIncapacidad()
    {
        return isset($this->Incapacidad) ? $this->Incapacidad : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIncapacidad method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIncapacidad method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIncapacidadForArrayConstraintsFromSetIncapacidad(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIncapacidadIncapacidadItem) {
            // validation for constraint: itemType
            if (!$arrayOfIncapacidadIncapacidadItem instanceof \StructType\Incapacidad) {
                $invalidValues[] = is_object($arrayOfIncapacidadIncapacidadItem) ? get_class($arrayOfIncapacidadIncapacidadItem) : sprintf('%s(%s)', gettype($arrayOfIncapacidadIncapacidadItem), var_export($arrayOfIncapacidadIncapacidadItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Incapacidad property can only contain items of type \StructType\Incapacidad, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Incapacidad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Incapacidad[] $incapacidad
     * @return \ArrayType\ArrayOfIncapacidad
     */
    public function setIncapacidad(array $incapacidad = array())
    {
        // validation for constraint: array
        if ('' !== ($incapacidadArrayErrorMessage = self::validateIncapacidadForArrayConstraintsFromSetIncapacidad($incapacidad))) {
            throw new \InvalidArgumentException($incapacidadArrayErrorMessage, __LINE__);
        }
        if (is_null($incapacidad) || (is_array($incapacidad) && empty($incapacidad))) {
            unset($this->Incapacidad);
        } else {
            $this->Incapacidad = $incapacidad;
        }
        return $this;
    }
    /**
     * Add item to Incapacidad value
     * @throws \InvalidArgumentException
     * @param \StructType\Incapacidad $item
     * @return \ArrayType\ArrayOfIncapacidad
     */
    public function addToIncapacidad(\StructType\Incapacidad $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Incapacidad) {
            throw new \InvalidArgumentException(sprintf('The Incapacidad property can only contain items of type \StructType\Incapacidad, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Incapacidad[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Incapacidad|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Incapacidad|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Incapacidad|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Incapacidad|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Incapacidad|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Incapacidad
     */
    public function getAttributeName()
    {
        return 'Incapacidad';
    }
}
