<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLicencia ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLicencia
 * @subpackage Arrays
 */
class ArrayOfLicencia extends AbstractStructArrayBase
{
    /**
     * The Licencia
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Licencia[]
     */
    public $Licencia;
    /**
     * Constructor method for ArrayOfLicencia
     * @uses ArrayOfLicencia::setLicencia()
     * @param \StructType\Licencia[] $licencia
     */
    public function __construct(array $licencia = array())
    {
        $this
            ->setLicencia($licencia);
    }
    /**
     * Get Licencia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Licencia[]|null
     */
    public function getLicencia()
    {
        return isset($this->Licencia) ? $this->Licencia : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLicencia method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLicencia method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLicenciaForArrayConstraintsFromSetLicencia(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLicenciaLicenciaItem) {
            // validation for constraint: itemType
            if (!$arrayOfLicenciaLicenciaItem instanceof \StructType\Licencia) {
                $invalidValues[] = is_object($arrayOfLicenciaLicenciaItem) ? get_class($arrayOfLicenciaLicenciaItem) : sprintf('%s(%s)', gettype($arrayOfLicenciaLicenciaItem), var_export($arrayOfLicenciaLicenciaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Licencia property can only contain items of type \StructType\Licencia, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Licencia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Licencia[] $licencia
     * @return \ArrayType\ArrayOfLicencia
     */
    public function setLicencia(array $licencia = array())
    {
        // validation for constraint: array
        if ('' !== ($licenciaArrayErrorMessage = self::validateLicenciaForArrayConstraintsFromSetLicencia($licencia))) {
            throw new \InvalidArgumentException($licenciaArrayErrorMessage, __LINE__);
        }
        if (is_null($licencia) || (is_array($licencia) && empty($licencia))) {
            unset($this->Licencia);
        } else {
            $this->Licencia = $licencia;
        }
        return $this;
    }
    /**
     * Add item to Licencia value
     * @throws \InvalidArgumentException
     * @param \StructType\Licencia $item
     * @return \ArrayType\ArrayOfLicencia
     */
    public function addToLicencia(\StructType\Licencia $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Licencia) {
            throw new \InvalidArgumentException(sprintf('The Licencia property can only contain items of type \StructType\Licencia, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Licencia[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Licencia|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Licencia|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Licencia|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Licencia|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Licencia|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Licencia
     */
    public function getAttributeName()
    {
        return 'Licencia';
    }
}
