<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOtraDeduccion ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOtraDeduccion
 * @subpackage Arrays
 */
class ArrayOfOtraDeduccion extends AbstractStructArrayBase
{
    /**
     * The OtraDeduccion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OtraDeduccion[]
     */
    public $OtraDeduccion;
    /**
     * Constructor method for ArrayOfOtraDeduccion
     * @uses ArrayOfOtraDeduccion::setOtraDeduccion()
     * @param \StructType\OtraDeduccion[] $otraDeduccion
     */
    public function __construct(array $otraDeduccion = array())
    {
        $this
            ->setOtraDeduccion($otraDeduccion);
    }
    /**
     * Get OtraDeduccion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OtraDeduccion[]|null
     */
    public function getOtraDeduccion()
    {
        return isset($this->OtraDeduccion) ? $this->OtraDeduccion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOtraDeduccion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOtraDeduccion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOtraDeduccionForArrayConstraintsFromSetOtraDeduccion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOtraDeduccionOtraDeduccionItem) {
            // validation for constraint: itemType
            if (!$arrayOfOtraDeduccionOtraDeduccionItem instanceof \StructType\OtraDeduccion) {
                $invalidValues[] = is_object($arrayOfOtraDeduccionOtraDeduccionItem) ? get_class($arrayOfOtraDeduccionOtraDeduccionItem) : sprintf('%s(%s)', gettype($arrayOfOtraDeduccionOtraDeduccionItem), var_export($arrayOfOtraDeduccionOtraDeduccionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OtraDeduccion property can only contain items of type \StructType\OtraDeduccion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OtraDeduccion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OtraDeduccion[] $otraDeduccion
     * @return \ArrayType\ArrayOfOtraDeduccion
     */
    public function setOtraDeduccion(array $otraDeduccion = array())
    {
        // validation for constraint: array
        if ('' !== ($otraDeduccionArrayErrorMessage = self::validateOtraDeduccionForArrayConstraintsFromSetOtraDeduccion($otraDeduccion))) {
            throw new \InvalidArgumentException($otraDeduccionArrayErrorMessage, __LINE__);
        }
        if (is_null($otraDeduccion) || (is_array($otraDeduccion) && empty($otraDeduccion))) {
            unset($this->OtraDeduccion);
        } else {
            $this->OtraDeduccion = $otraDeduccion;
        }
        return $this;
    }
    /**
     * Add item to OtraDeduccion value
     * @throws \InvalidArgumentException
     * @param \StructType\OtraDeduccion $item
     * @return \ArrayType\ArrayOfOtraDeduccion
     */
    public function addToOtraDeduccion(\StructType\OtraDeduccion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OtraDeduccion) {
            throw new \InvalidArgumentException(sprintf('The OtraDeduccion property can only contain items of type \StructType\OtraDeduccion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OtraDeduccion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OtraDeduccion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OtraDeduccion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OtraDeduccion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OtraDeduccion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OtraDeduccion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OtraDeduccion
     */
    public function getAttributeName()
    {
        return 'OtraDeduccion';
    }
}
