<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOtroConcepto ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOtroConcepto
 * @subpackage Arrays
 */
class ArrayOfOtroConcepto extends AbstractStructArrayBase
{
    /**
     * The OtroConcepto
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OtroConcepto[]
     */
    public $OtroConcepto;
    /**
     * Constructor method for ArrayOfOtroConcepto
     * @uses ArrayOfOtroConcepto::setOtroConcepto()
     * @param \StructType\OtroConcepto[] $otroConcepto
     */
    public function __construct(array $otroConcepto = array())
    {
        $this
            ->setOtroConcepto($otroConcepto);
    }
    /**
     * Get OtroConcepto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OtroConcepto[]|null
     */
    public function getOtroConcepto()
    {
        return isset($this->OtroConcepto) ? $this->OtroConcepto : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOtroConcepto method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOtroConcepto method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOtroConceptoForArrayConstraintsFromSetOtroConcepto(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOtroConceptoOtroConceptoItem) {
            // validation for constraint: itemType
            if (!$arrayOfOtroConceptoOtroConceptoItem instanceof \StructType\OtroConcepto) {
                $invalidValues[] = is_object($arrayOfOtroConceptoOtroConceptoItem) ? get_class($arrayOfOtroConceptoOtroConceptoItem) : sprintf('%s(%s)', gettype($arrayOfOtroConceptoOtroConceptoItem), var_export($arrayOfOtroConceptoOtroConceptoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OtroConcepto property can only contain items of type \StructType\OtroConcepto, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OtroConcepto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OtroConcepto[] $otroConcepto
     * @return \ArrayType\ArrayOfOtroConcepto
     */
    public function setOtroConcepto(array $otroConcepto = array())
    {
        // validation for constraint: array
        if ('' !== ($otroConceptoArrayErrorMessage = self::validateOtroConceptoForArrayConstraintsFromSetOtroConcepto($otroConcepto))) {
            throw new \InvalidArgumentException($otroConceptoArrayErrorMessage, __LINE__);
        }
        if (is_null($otroConcepto) || (is_array($otroConcepto) && empty($otroConcepto))) {
            unset($this->OtroConcepto);
        } else {
            $this->OtroConcepto = $otroConcepto;
        }
        return $this;
    }
    /**
     * Add item to OtroConcepto value
     * @throws \InvalidArgumentException
     * @param \StructType\OtroConcepto $item
     * @return \ArrayType\ArrayOfOtroConcepto
     */
    public function addToOtroConcepto(\StructType\OtroConcepto $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OtroConcepto) {
            throw new \InvalidArgumentException(sprintf('The OtroConcepto property can only contain items of type \StructType\OtroConcepto, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OtroConcepto[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OtroConcepto|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OtroConcepto|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OtroConcepto|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OtroConcepto|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OtroConcepto|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OtroConcepto
     */
    public function getAttributeName()
    {
        return 'OtroConcepto';
    }
}
