<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPagoTercero ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPagoTercero
 * @subpackage Arrays
 */
class ArrayOfPagoTercero extends AbstractStructArrayBase
{
    /**
     * The PagoTercero
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PagoTercero[]
     */
    public $PagoTercero;
    /**
     * Constructor method for ArrayOfPagoTercero
     * @uses ArrayOfPagoTercero::setPagoTercero()
     * @param \StructType\PagoTercero[] $pagoTercero
     */
    public function __construct(array $pagoTercero = array())
    {
        $this
            ->setPagoTercero($pagoTercero);
    }
    /**
     * Get PagoTercero value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PagoTercero[]|null
     */
    public function getPagoTercero()
    {
        return isset($this->PagoTercero) ? $this->PagoTercero : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPagoTercero method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPagoTercero method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePagoTerceroForArrayConstraintsFromSetPagoTercero(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPagoTerceroPagoTerceroItem) {
            // validation for constraint: itemType
            if (!$arrayOfPagoTerceroPagoTerceroItem instanceof \StructType\PagoTercero) {
                $invalidValues[] = is_object($arrayOfPagoTerceroPagoTerceroItem) ? get_class($arrayOfPagoTerceroPagoTerceroItem) : sprintf('%s(%s)', gettype($arrayOfPagoTerceroPagoTerceroItem), var_export($arrayOfPagoTerceroPagoTerceroItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PagoTercero property can only contain items of type \StructType\PagoTercero, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PagoTercero value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PagoTercero[] $pagoTercero
     * @return \ArrayType\ArrayOfPagoTercero
     */
    public function setPagoTercero(array $pagoTercero = array())
    {
        // validation for constraint: array
        if ('' !== ($pagoTerceroArrayErrorMessage = self::validatePagoTerceroForArrayConstraintsFromSetPagoTercero($pagoTercero))) {
            throw new \InvalidArgumentException($pagoTerceroArrayErrorMessage, __LINE__);
        }
        if (is_null($pagoTercero) || (is_array($pagoTercero) && empty($pagoTercero))) {
            unset($this->PagoTercero);
        } else {
            $this->PagoTercero = $pagoTercero;
        }
        return $this;
    }
    /**
     * Add item to PagoTercero value
     * @throws \InvalidArgumentException
     * @param \StructType\PagoTercero $item
     * @return \ArrayType\ArrayOfPagoTercero
     */
    public function addToPagoTercero(\StructType\PagoTercero $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PagoTercero) {
            throw new \InvalidArgumentException(sprintf('The PagoTercero property can only contain items of type \StructType\PagoTercero, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PagoTercero[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PagoTercero|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PagoTercero|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PagoTercero|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PagoTercero|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PagoTercero|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PagoTercero
     */
    public function getAttributeName()
    {
        return 'PagoTercero';
    }
}
