<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrima ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPrima
 * @subpackage Arrays
 */
class ArrayOfPrima extends AbstractStructArrayBase
{
    /**
     * The Prima
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Prima[]
     */
    public $Prima;
    /**
     * Constructor method for ArrayOfPrima
     * @uses ArrayOfPrima::setPrima()
     * @param \StructType\Prima[] $prima
     */
    public function __construct(array $prima = array())
    {
        $this
            ->setPrima($prima);
    }
    /**
     * Get Prima value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Prima[]|null
     */
    public function getPrima()
    {
        return isset($this->Prima) ? $this->Prima : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrima method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrima method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrimaForArrayConstraintsFromSetPrima(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPrimaPrimaItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrimaPrimaItem instanceof \StructType\Prima) {
                $invalidValues[] = is_object($arrayOfPrimaPrimaItem) ? get_class($arrayOfPrimaPrimaItem) : sprintf('%s(%s)', gettype($arrayOfPrimaPrimaItem), var_export($arrayOfPrimaPrimaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Prima property can only contain items of type \StructType\Prima, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Prima value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Prima[] $prima
     * @return \ArrayType\ArrayOfPrima
     */
    public function setPrima(array $prima = array())
    {
        // validation for constraint: array
        if ('' !== ($primaArrayErrorMessage = self::validatePrimaForArrayConstraintsFromSetPrima($prima))) {
            throw new \InvalidArgumentException($primaArrayErrorMessage, __LINE__);
        }
        if (is_null($prima) || (is_array($prima) && empty($prima))) {
            unset($this->Prima);
        } else {
            $this->Prima = $prima;
        }
        return $this;
    }
    /**
     * Add item to Prima value
     * @throws \InvalidArgumentException
     * @param \StructType\Prima $item
     * @return \ArrayType\ArrayOfPrima
     */
    public function addToPrima(\StructType\Prima $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Prima) {
            throw new \InvalidArgumentException(sprintf('The Prima property can only contain items of type \StructType\Prima, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Prima[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Prima|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Prima|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Prima|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Prima|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Prima|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Prima
     */
    public function getAttributeName()
    {
        return 'Prima';
    }
}
