<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSancion ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSancion
 * @subpackage Arrays
 */
class ArrayOfSancion extends AbstractStructArrayBase
{
    /**
     * The Sancion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Sancion[]
     */
    public $Sancion;
    /**
     * Constructor method for ArrayOfSancion
     * @uses ArrayOfSancion::setSancion()
     * @param \StructType\Sancion[] $sancion
     */
    public function __construct(array $sancion = array())
    {
        $this
            ->setSancion($sancion);
    }
    /**
     * Get Sancion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Sancion[]|null
     */
    public function getSancion()
    {
        return isset($this->Sancion) ? $this->Sancion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSancion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSancion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSancionForArrayConstraintsFromSetSancion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSancionSancionItem) {
            // validation for constraint: itemType
            if (!$arrayOfSancionSancionItem instanceof \StructType\Sancion) {
                $invalidValues[] = is_object($arrayOfSancionSancionItem) ? get_class($arrayOfSancionSancionItem) : sprintf('%s(%s)', gettype($arrayOfSancionSancionItem), var_export($arrayOfSancionSancionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Sancion property can only contain items of type \StructType\Sancion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Sancion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Sancion[] $sancion
     * @return \ArrayType\ArrayOfSancion
     */
    public function setSancion(array $sancion = array())
    {
        // validation for constraint: array
        if ('' !== ($sancionArrayErrorMessage = self::validateSancionForArrayConstraintsFromSetSancion($sancion))) {
            throw new \InvalidArgumentException($sancionArrayErrorMessage, __LINE__);
        }
        if (is_null($sancion) || (is_array($sancion) && empty($sancion))) {
            unset($this->Sancion);
        } else {
            $this->Sancion = $sancion;
        }
        return $this;
    }
    /**
     * Add item to Sancion value
     * @throws \InvalidArgumentException
     * @param \StructType\Sancion $item
     * @return \ArrayType\ArrayOfSancion
     */
    public function addToSancion(\StructType\Sancion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Sancion) {
            throw new \InvalidArgumentException(sprintf('The Sancion property can only contain items of type \StructType\Sancion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Sancion[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Sancion|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Sancion|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Sancion|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Sancion|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Sancion|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Sancion
     */
    public function getAttributeName()
    {
        return 'Sancion';
    }
}
