<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransporte ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransporte
 * @subpackage Arrays
 */
class ArrayOfTransporte extends AbstractStructArrayBase
{
    /**
     * The Transporte
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Transporte[]
     */
    public $Transporte;
    /**
     * Constructor method for ArrayOfTransporte
     * @uses ArrayOfTransporte::setTransporte()
     * @param \StructType\Transporte[] $transporte
     */
    public function __construct(array $transporte = array())
    {
        $this
            ->setTransporte($transporte);
    }
    /**
     * Get Transporte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Transporte[]|null
     */
    public function getTransporte()
    {
        return isset($this->Transporte) ? $this->Transporte : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransporte method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransporte method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransporteForArrayConstraintsFromSetTransporte(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransporteTransporteItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransporteTransporteItem instanceof \StructType\Transporte) {
                $invalidValues[] = is_object($arrayOfTransporteTransporteItem) ? get_class($arrayOfTransporteTransporteItem) : sprintf('%s(%s)', gettype($arrayOfTransporteTransporteItem), var_export($arrayOfTransporteTransporteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Transporte property can only contain items of type \StructType\Transporte, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Transporte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Transporte[] $transporte
     * @return \ArrayType\ArrayOfTransporte
     */
    public function setTransporte(array $transporte = array())
    {
        // validation for constraint: array
        if ('' !== ($transporteArrayErrorMessage = self::validateTransporteForArrayConstraintsFromSetTransporte($transporte))) {
            throw new \InvalidArgumentException($transporteArrayErrorMessage, __LINE__);
        }
        if (is_null($transporte) || (is_array($transporte) && empty($transporte))) {
            unset($this->Transporte);
        } else {
            $this->Transporte = $transporte;
        }
        return $this;
    }
    /**
     * Add item to Transporte value
     * @throws \InvalidArgumentException
     * @param \StructType\Transporte $item
     * @return \ArrayType\ArrayOfTransporte
     */
    public function addToTransporte(\StructType\Transporte $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Transporte) {
            throw new \InvalidArgumentException(sprintf('The Transporte property can only contain items of type \StructType\Transporte, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Transporte[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Transporte|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Transporte|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Transporte|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Transporte|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Transporte|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Transporte
     */
    public function getAttributeName()
    {
        return 'Transporte';
    }
}
