<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVacaciones ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVacaciones
 * @subpackage Arrays
 */
class ArrayOfVacaciones extends AbstractStructArrayBase
{
    /**
     * The Vacaciones
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Vacaciones[]
     */
    public $Vacaciones;
    /**
     * Constructor method for ArrayOfVacaciones
     * @uses ArrayOfVacaciones::setVacaciones()
     * @param \StructType\Vacaciones[] $vacaciones
     */
    public function __construct(array $vacaciones = array())
    {
        $this
            ->setVacaciones($vacaciones);
    }
    /**
     * Get Vacaciones value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Vacaciones[]|null
     */
    public function getVacaciones()
    {
        return isset($this->Vacaciones) ? $this->Vacaciones : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVacaciones method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVacaciones method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVacacionesForArrayConstraintsFromSetVacaciones(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVacacionesVacacionesItem) {
            // validation for constraint: itemType
            if (!$arrayOfVacacionesVacacionesItem instanceof \StructType\Vacaciones) {
                $invalidValues[] = is_object($arrayOfVacacionesVacacionesItem) ? get_class($arrayOfVacacionesVacacionesItem) : sprintf('%s(%s)', gettype($arrayOfVacacionesVacacionesItem), var_export($arrayOfVacacionesVacacionesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Vacaciones property can only contain items of type \StructType\Vacaciones, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Vacaciones value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Vacaciones[] $vacaciones
     * @return \ArrayType\ArrayOfVacaciones
     */
    public function setVacaciones(array $vacaciones = array())
    {
        // validation for constraint: array
        if ('' !== ($vacacionesArrayErrorMessage = self::validateVacacionesForArrayConstraintsFromSetVacaciones($vacaciones))) {
            throw new \InvalidArgumentException($vacacionesArrayErrorMessage, __LINE__);
        }
        if (is_null($vacaciones) || (is_array($vacaciones) && empty($vacaciones))) {
            unset($this->Vacaciones);
        } else {
            $this->Vacaciones = $vacaciones;
        }
        return $this;
    }
    /**
     * Add item to Vacaciones value
     * @throws \InvalidArgumentException
     * @param \StructType\Vacaciones $item
     * @return \ArrayType\ArrayOfVacaciones
     */
    public function addToVacaciones(\StructType\Vacaciones $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Vacaciones) {
            throw new \InvalidArgumentException(sprintf('The Vacaciones property can only contain items of type \StructType\Vacaciones, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Vacaciones[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Vacaciones|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Vacaciones|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Vacaciones|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Vacaciones|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Vacaciones|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Vacaciones
     */
    public function getAttributeName()
    {
        return 'Vacaciones';
    }
}
