<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'NominaGeneral' => '\\StructType\\NominaGeneral',
            'Deduccion' => '\\StructType\\Deduccion',
            'ArrayOfAnticipoNom' => '\\ArrayType\\ArrayOfAnticipoNom',
            'AnticipoNom' => '\\StructType\\AnticipoNom',
            'ArrayOfExtensibleNom' => '\\ArrayType\\ArrayOfExtensibleNom',
            'ExtensibleNom' => '\\StructType\\ExtensibleNom',
            'ArrayOfFondoPension' => '\\ArrayType\\ArrayOfFondoPension',
            'FondoPension' => '\\StructType\\FondoPension',
            'ArrayOfFondoSP' => '\\ArrayType\\ArrayOfFondoSP',
            'FondoSP' => '\\StructType\\FondoSP',
            'ArrayOfLibranza' => '\\ArrayType\\ArrayOfLibranza',
            'Libranza' => '\\StructType\\Libranza',
            'ArrayOfOtraDeduccion' => '\\ArrayType\\ArrayOfOtraDeduccion',
            'OtraDeduccion' => '\\StructType\\OtraDeduccion',
            'ArrayOfPagoTercero' => '\\ArrayType\\ArrayOfPagoTercero',
            'PagoTercero' => '\\StructType\\PagoTercero',
            'ArrayOfSalud' => '\\ArrayType\\ArrayOfSalud',
            'Salud' => '\\StructType\\Salud',
            'ArrayOfSancion' => '\\ArrayType\\ArrayOfSancion',
            'Sancion' => '\\StructType\\Sancion',
            'ArrayOfSindicato' => '\\ArrayType\\ArrayOfSindicato',
            'Sindicato' => '\\StructType\\Sindicato',
            'Devengado' => '\\StructType\\Devengado',
            'ArrayOfAuxilio' => '\\ArrayType\\ArrayOfAuxilio',
            'Auxilio' => '\\StructType\\Auxilio',
            'ArrayOfBasico' => '\\ArrayType\\ArrayOfBasico',
            'Basico' => '\\StructType\\Basico',
            'ArrayOfBonificacion' => '\\ArrayType\\ArrayOfBonificacion',
            'Bonificacion' => '\\StructType\\Bonificacion',
            'ArrayOfBonoEPCTV' => '\\ArrayType\\ArrayOfBonoEPCTV',
            'BonoEPCTV' => '\\StructType\\BonoEPCTV',
            'ArrayOfCesantia' => '\\ArrayType\\ArrayOfCesantia',
            'Cesantia' => '\\StructType\\Cesantia',
            'ArrayOfComision' => '\\ArrayType\\ArrayOfComision',
            'Comision' => '\\StructType\\Comision',
            'ArrayOfCompensacion' => '\\ArrayType\\ArrayOfCompensacion',
            'Compensacion' => '\\StructType\\Compensacion',
            'ArrayOfHoraExtra' => '\\ArrayType\\ArrayOfHoraExtra',
            'HoraExtra' => '\\StructType\\HoraExtra',
            'ArrayOfHuelgaLegal' => '\\ArrayType\\ArrayOfHuelgaLegal',
            'HuelgaLegal' => '\\StructType\\HuelgaLegal',
            'ArrayOfIncapacidad' => '\\ArrayType\\ArrayOfIncapacidad',
            'Incapacidad' => '\\StructType\\Incapacidad',
            'Licencias' => '\\StructType\\Licencias',
            'ArrayOfLicencia' => '\\ArrayType\\ArrayOfLicencia',
            'Licencia' => '\\StructType\\Licencia',
            'ArrayOfOtroConcepto' => '\\ArrayType\\ArrayOfOtroConcepto',
            'OtroConcepto' => '\\StructType\\OtroConcepto',
            'ArrayOfPrima' => '\\ArrayType\\ArrayOfPrima',
            'Prima' => '\\StructType\\Prima',
            'ArrayOfTransporte' => '\\ArrayType\\ArrayOfTransporte',
            'Transporte' => '\\StructType\\Transporte',
            'Vacacion' => '\\StructType\\Vacacion',
            'ArrayOfVacaciones' => '\\ArrayType\\ArrayOfVacaciones',
            'Vacaciones' => '\\StructType\\Vacaciones',
            'ArrayOfDocumentoReferenciadoNom' => '\\ArrayType\\ArrayOfDocumentoReferenciadoNom',
            'DocumentoReferenciadoNom' => '\\StructType\\DocumentoReferenciadoNom',
            'LugarGeneracionXML' => '\\StructType\\LugarGeneracionXML',
            'ArrayOfNota' => '\\ArrayType\\ArrayOfNota',
            'Nota' => '\\StructType\\Nota',
            'ArrayOfPago' => '\\ArrayType\\ArrayOfPago',
            'Pago' => '\\StructType\\Pago',
            'ArrayOfFechaPago' => '\\ArrayType\\ArrayOfFechaPago',
            'FechaPago' => '\\StructType\\FechaPago',
            'ArrayOfPeriodo' => '\\ArrayType\\ArrayOfPeriodo',
            'Periodo' => '\\StructType\\Periodo',
            'Trabajador' => '\\StructType\\Trabajador',
            'Request' => '\\StructType\\Request',
            'RequestConsultar' => '\\StructType\\RequestConsultar',
            'RequestConsultarDocumento' => '\\StructType\\RequestConsultarDocumento',
            'RequestEnviarCorreo' => '\\StructType\\RequestEnviarCorreo',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'Response' => '\\StructType\\Response',
            'ResponseFoliosRemaining' => '\\StructType\\ResponseFoliosRemaining',
            'ResponseStatusDocument' => '\\StructType\\ResponseStatusDocument',
            'ResponseDownloadDocument' => '\\StructType\\ResponseDownloadDocument',
            'ResponseSendEmail' => '\\StructType\\ResponseSendEmail',
            'Enviar' => '\\StructType\\Enviar',
            'EnviarResponse' => '\\StructType\\EnviarResponse',
            'FoliosRestantes' => '\\StructType\\FoliosRestantes',
            'FoliosRestantesResponse' => '\\StructType\\FoliosRestantesResponse',
            'EstadoDocumento' => '\\StructType\\EstadoDocumento',
            'EstadoDocumentoResponse' => '\\StructType\\EstadoDocumentoResponse',
            'DescargaXML' => '\\StructType\\DescargaXML',
            'DescargaXMLResponse' => '\\StructType\\DescargaXMLResponse',
            'DescargaPDF' => '\\StructType\\DescargaPDF',
            'DescargaPDFResponse' => '\\StructType\\DescargaPDFResponse',
            'EnvioCorreo' => '\\StructType\\EnvioCorreo',
            'EnvioCorreoResponse' => '\\StructType\\EnvioCorreoResponse',
            'DescargaAppResponse' => '\\StructType\\DescargaAppResponse',
            'DescargaAppResponseResponse' => '\\StructType\\DescargaAppResponseResponse',
        );
    }
}
