<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Auxilio StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Auxilio
 * @subpackage Structs
 */
class Auxilio extends AbstractStructBase
{
    /**
     * The auxilioNS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $auxilioNS;
    /**
     * The auxilioS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $auxilioS;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * Constructor method for Auxilio
     * @uses Auxilio::setAuxilioNS()
     * @uses Auxilio::setAuxilioS()
     * @uses Auxilio::setExtrasNom()
     * @param string $auxilioNS
     * @param string $auxilioS
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     */
    public function __construct($auxilioNS = null, $auxilioS = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        $this
            ->setAuxilioNS($auxilioNS)
            ->setAuxilioS($auxilioS)
            ->setExtrasNom($extrasNom);
    }
    /**
     * Get auxilioNS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAuxilioNS()
    {
        return isset($this->auxilioNS) ? $this->auxilioNS : null;
    }
    /**
     * Set auxilioNS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $auxilioNS
     * @return \StructType\Auxilio
     */
    public function setAuxilioNS($auxilioNS = null)
    {
        // validation for constraint: string
        if (!is_null($auxilioNS) && !is_string($auxilioNS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($auxilioNS, true), gettype($auxilioNS)), __LINE__);
        }
        if (is_null($auxilioNS) || (is_array($auxilioNS) && empty($auxilioNS))) {
            unset($this->auxilioNS);
        } else {
            $this->auxilioNS = $auxilioNS;
        }
        return $this;
    }
    /**
     * Get auxilioS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAuxilioS()
    {
        return isset($this->auxilioS) ? $this->auxilioS : null;
    }
    /**
     * Set auxilioS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $auxilioS
     * @return \StructType\Auxilio
     */
    public function setAuxilioS($auxilioS = null)
    {
        // validation for constraint: string
        if (!is_null($auxilioS) && !is_string($auxilioS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($auxilioS, true), gettype($auxilioS)), __LINE__);
        }
        if (is_null($auxilioS) || (is_array($auxilioS) && empty($auxilioS))) {
            unset($this->auxilioS);
        } else {
            $this->auxilioS = $auxilioS;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Auxilio
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
}
