<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Basico StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Basico
 * @subpackage Structs
 */
class Basico extends AbstractStructBase
{
    /**
     * The diasTrabajados
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $diasTrabajados;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The sueldoTrabajado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sueldoTrabajado;
    /**
     * Constructor method for Basico
     * @uses Basico::setDiasTrabajados()
     * @uses Basico::setExtrasNom()
     * @uses Basico::setSueldoTrabajado()
     * @param string $diasTrabajados
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $sueldoTrabajado
     */
    public function __construct($diasTrabajados = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $sueldoTrabajado = null)
    {
        $this
            ->setDiasTrabajados($diasTrabajados)
            ->setExtrasNom($extrasNom)
            ->setSueldoTrabajado($sueldoTrabajado);
    }
    /**
     * Get diasTrabajados value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDiasTrabajados()
    {
        return isset($this->diasTrabajados) ? $this->diasTrabajados : null;
    }
    /**
     * Set diasTrabajados value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $diasTrabajados
     * @return \StructType\Basico
     */
    public function setDiasTrabajados($diasTrabajados = null)
    {
        // validation for constraint: string
        if (!is_null($diasTrabajados) && !is_string($diasTrabajados)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($diasTrabajados, true), gettype($diasTrabajados)), __LINE__);
        }
        if (is_null($diasTrabajados) || (is_array($diasTrabajados) && empty($diasTrabajados))) {
            unset($this->diasTrabajados);
        } else {
            $this->diasTrabajados = $diasTrabajados;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Basico
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get sueldoTrabajado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSueldoTrabajado()
    {
        return isset($this->sueldoTrabajado) ? $this->sueldoTrabajado : null;
    }
    /**
     * Set sueldoTrabajado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sueldoTrabajado
     * @return \StructType\Basico
     */
    public function setSueldoTrabajado($sueldoTrabajado = null)
    {
        // validation for constraint: string
        if (!is_null($sueldoTrabajado) && !is_string($sueldoTrabajado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sueldoTrabajado, true), gettype($sueldoTrabajado)), __LINE__);
        }
        if (is_null($sueldoTrabajado) || (is_array($sueldoTrabajado) && empty($sueldoTrabajado))) {
            unset($this->sueldoTrabajado);
        } else {
            $this->sueldoTrabajado = $sueldoTrabajado;
        }
        return $this;
    }
}
