<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cesantia StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Cesantia
 * @subpackage Structs
 */
class Cesantia extends AbstractStructBase
{
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The pago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pago;
    /**
     * The pagoIntereses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pagoIntereses;
    /**
     * The porcentaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $porcentaje;
    /**
     * Constructor method for Cesantia
     * @uses Cesantia::setExtrasNom()
     * @uses Cesantia::setPago()
     * @uses Cesantia::setPagoIntereses()
     * @uses Cesantia::setPorcentaje()
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $pago
     * @param string $pagoIntereses
     * @param string $porcentaje
     */
    public function __construct(\ArrayType\ArrayOfExtensibleNom $extrasNom = null, $pago = null, $pagoIntereses = null, $porcentaje = null)
    {
        $this
            ->setExtrasNom($extrasNom)
            ->setPago($pago)
            ->setPagoIntereses($pagoIntereses)
            ->setPorcentaje($porcentaje);
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Cesantia
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get pago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPago()
    {
        return isset($this->pago) ? $this->pago : null;
    }
    /**
     * Set pago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pago
     * @return \StructType\Cesantia
     */
    public function setPago($pago = null)
    {
        // validation for constraint: string
        if (!is_null($pago) && !is_string($pago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pago, true), gettype($pago)), __LINE__);
        }
        if (is_null($pago) || (is_array($pago) && empty($pago))) {
            unset($this->pago);
        } else {
            $this->pago = $pago;
        }
        return $this;
    }
    /**
     * Get pagoIntereses value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPagoIntereses()
    {
        return isset($this->pagoIntereses) ? $this->pagoIntereses : null;
    }
    /**
     * Set pagoIntereses value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pagoIntereses
     * @return \StructType\Cesantia
     */
    public function setPagoIntereses($pagoIntereses = null)
    {
        // validation for constraint: string
        if (!is_null($pagoIntereses) && !is_string($pagoIntereses)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pagoIntereses, true), gettype($pagoIntereses)), __LINE__);
        }
        if (is_null($pagoIntereses) || (is_array($pagoIntereses) && empty($pagoIntereses))) {
            unset($this->pagoIntereses);
        } else {
            $this->pagoIntereses = $pagoIntereses;
        }
        return $this;
    }
    /**
     * Get porcentaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPorcentaje()
    {
        return isset($this->porcentaje) ? $this->porcentaje : null;
    }
    /**
     * Set porcentaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $porcentaje
     * @return \StructType\Cesantia
     */
    public function setPorcentaje($porcentaje = null)
    {
        // validation for constraint: string
        if (!is_null($porcentaje) && !is_string($porcentaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($porcentaje, true), gettype($porcentaje)), __LINE__);
        }
        if (is_null($porcentaje) || (is_array($porcentaje) && empty($porcentaje))) {
            unset($this->porcentaje);
        } else {
            $this->porcentaje = $porcentaje;
        }
        return $this;
    }
}
