<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocumentoReferenciadoNom StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DocumentoReferenciadoNom
 * @subpackage Structs
 */
class DocumentoReferenciadoNom extends AbstractStructBase
{
    /**
     * The cunePred
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cunePred;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The fechaGenPred
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaGenPred;
    /**
     * The numeroPred
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numeroPred;
    /**
     * Constructor method for DocumentoReferenciadoNom
     * @uses DocumentoReferenciadoNom::setCunePred()
     * @uses DocumentoReferenciadoNom::setExtrasNom()
     * @uses DocumentoReferenciadoNom::setFechaGenPred()
     * @uses DocumentoReferenciadoNom::setNumeroPred()
     * @param string $cunePred
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $fechaGenPred
     * @param string $numeroPred
     */
    public function __construct($cunePred = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $fechaGenPred = null, $numeroPred = null)
    {
        $this
            ->setCunePred($cunePred)
            ->setExtrasNom($extrasNom)
            ->setFechaGenPred($fechaGenPred)
            ->setNumeroPred($numeroPred);
    }
    /**
     * Get cunePred value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCunePred()
    {
        return isset($this->cunePred) ? $this->cunePred : null;
    }
    /**
     * Set cunePred value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cunePred
     * @return \StructType\DocumentoReferenciadoNom
     */
    public function setCunePred($cunePred = null)
    {
        // validation for constraint: string
        if (!is_null($cunePred) && !is_string($cunePred)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cunePred, true), gettype($cunePred)), __LINE__);
        }
        if (is_null($cunePred) || (is_array($cunePred) && empty($cunePred))) {
            unset($this->cunePred);
        } else {
            $this->cunePred = $cunePred;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\DocumentoReferenciadoNom
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get fechaGenPred value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaGenPred()
    {
        return isset($this->fechaGenPred) ? $this->fechaGenPred : null;
    }
    /**
     * Set fechaGenPred value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaGenPred
     * @return \StructType\DocumentoReferenciadoNom
     */
    public function setFechaGenPred($fechaGenPred = null)
    {
        // validation for constraint: string
        if (!is_null($fechaGenPred) && !is_string($fechaGenPred)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaGenPred, true), gettype($fechaGenPred)), __LINE__);
        }
        if (is_null($fechaGenPred) || (is_array($fechaGenPred) && empty($fechaGenPred))) {
            unset($this->fechaGenPred);
        } else {
            $this->fechaGenPred = $fechaGenPred;
        }
        return $this;
    }
    /**
     * Get numeroPred value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroPred()
    {
        return isset($this->numeroPred) ? $this->numeroPred : null;
    }
    /**
     * Set numeroPred value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroPred
     * @return \StructType\DocumentoReferenciadoNom
     */
    public function setNumeroPred($numeroPred = null)
    {
        // validation for constraint: string
        if (!is_null($numeroPred) && !is_string($numeroPred)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroPred, true), gettype($numeroPred)), __LINE__);
        }
        if (is_null($numeroPred) || (is_array($numeroPred) && empty($numeroPred))) {
            unset($this->numeroPred);
        } else {
            $this->numeroPred = $numeroPred;
        }
        return $this;
    }
}
