<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FondoPension StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FondoPension
 * @subpackage Structs
 */
class FondoPension extends AbstractStructBase
{
    /**
     * The deduccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $deduccion;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The porcentaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $porcentaje;
    /**
     * Constructor method for FondoPension
     * @uses FondoPension::setDeduccion()
     * @uses FondoPension::setExtrasNom()
     * @uses FondoPension::setPorcentaje()
     * @param string $deduccion
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $porcentaje
     */
    public function __construct($deduccion = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $porcentaje = null)
    {
        $this
            ->setDeduccion($deduccion)
            ->setExtrasNom($extrasNom)
            ->setPorcentaje($porcentaje);
    }
    /**
     * Get deduccion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeduccion()
    {
        return isset($this->deduccion) ? $this->deduccion : null;
    }
    /**
     * Set deduccion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deduccion
     * @return \StructType\FondoPension
     */
    public function setDeduccion($deduccion = null)
    {
        // validation for constraint: string
        if (!is_null($deduccion) && !is_string($deduccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deduccion, true), gettype($deduccion)), __LINE__);
        }
        if (is_null($deduccion) || (is_array($deduccion) && empty($deduccion))) {
            unset($this->deduccion);
        } else {
            $this->deduccion = $deduccion;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\FondoPension
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get porcentaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPorcentaje()
    {
        return isset($this->porcentaje) ? $this->porcentaje : null;
    }
    /**
     * Set porcentaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $porcentaje
     * @return \StructType\FondoPension
     */
    public function setPorcentaje($porcentaje = null)
    {
        // validation for constraint: string
        if (!is_null($porcentaje) && !is_string($porcentaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($porcentaje, true), gettype($porcentaje)), __LINE__);
        }
        if (is_null($porcentaje) || (is_array($porcentaje) && empty($porcentaje))) {
            unset($this->porcentaje);
        } else {
            $this->porcentaje = $porcentaje;
        }
        return $this;
    }
}
