<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FondoSP StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FondoSP
 * @subpackage Structs
 */
class FondoSP extends AbstractStructBase
{
    /**
     * The deduccionSP
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $deduccionSP;
    /**
     * The deduccionSub
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $deduccionSub;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The porcentaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $porcentaje;
    /**
     * The porcentajeSub
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $porcentajeSub;
    /**
     * Constructor method for FondoSP
     * @uses FondoSP::setDeduccionSP()
     * @uses FondoSP::setDeduccionSub()
     * @uses FondoSP::setExtrasNom()
     * @uses FondoSP::setPorcentaje()
     * @uses FondoSP::setPorcentajeSub()
     * @param string $deduccionSP
     * @param string $deduccionSub
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $porcentaje
     * @param string $porcentajeSub
     */
    public function __construct($deduccionSP = null, $deduccionSub = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $porcentaje = null, $porcentajeSub = null)
    {
        $this
            ->setDeduccionSP($deduccionSP)
            ->setDeduccionSub($deduccionSub)
            ->setExtrasNom($extrasNom)
            ->setPorcentaje($porcentaje)
            ->setPorcentajeSub($porcentajeSub);
    }
    /**
     * Get deduccionSP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeduccionSP()
    {
        return isset($this->deduccionSP) ? $this->deduccionSP : null;
    }
    /**
     * Set deduccionSP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deduccionSP
     * @return \StructType\FondoSP
     */
    public function setDeduccionSP($deduccionSP = null)
    {
        // validation for constraint: string
        if (!is_null($deduccionSP) && !is_string($deduccionSP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deduccionSP, true), gettype($deduccionSP)), __LINE__);
        }
        if (is_null($deduccionSP) || (is_array($deduccionSP) && empty($deduccionSP))) {
            unset($this->deduccionSP);
        } else {
            $this->deduccionSP = $deduccionSP;
        }
        return $this;
    }
    /**
     * Get deduccionSub value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeduccionSub()
    {
        return isset($this->deduccionSub) ? $this->deduccionSub : null;
    }
    /**
     * Set deduccionSub value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deduccionSub
     * @return \StructType\FondoSP
     */
    public function setDeduccionSub($deduccionSub = null)
    {
        // validation for constraint: string
        if (!is_null($deduccionSub) && !is_string($deduccionSub)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deduccionSub, true), gettype($deduccionSub)), __LINE__);
        }
        if (is_null($deduccionSub) || (is_array($deduccionSub) && empty($deduccionSub))) {
            unset($this->deduccionSub);
        } else {
            $this->deduccionSub = $deduccionSub;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\FondoSP
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get porcentaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPorcentaje()
    {
        return isset($this->porcentaje) ? $this->porcentaje : null;
    }
    /**
     * Set porcentaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $porcentaje
     * @return \StructType\FondoSP
     */
    public function setPorcentaje($porcentaje = null)
    {
        // validation for constraint: string
        if (!is_null($porcentaje) && !is_string($porcentaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($porcentaje, true), gettype($porcentaje)), __LINE__);
        }
        if (is_null($porcentaje) || (is_array($porcentaje) && empty($porcentaje))) {
            unset($this->porcentaje);
        } else {
            $this->porcentaje = $porcentaje;
        }
        return $this;
    }
    /**
     * Get porcentajeSub value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPorcentajeSub()
    {
        return isset($this->porcentajeSub) ? $this->porcentajeSub : null;
    }
    /**
     * Set porcentajeSub value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $porcentajeSub
     * @return \StructType\FondoSP
     */
    public function setPorcentajeSub($porcentajeSub = null)
    {
        // validation for constraint: string
        if (!is_null($porcentajeSub) && !is_string($porcentajeSub)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($porcentajeSub, true), gettype($porcentajeSub)), __LINE__);
        }
        if (is_null($porcentajeSub) || (is_array($porcentajeSub) && empty($porcentajeSub))) {
            unset($this->porcentajeSub);
        } else {
            $this->porcentajeSub = $porcentajeSub;
        }
        return $this;
    }
}
