<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HoraExtra StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:HoraExtra
 * @subpackage Structs
 */
class HoraExtra extends AbstractStructBase
{
    /**
     * The cantidad
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cantidad;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The horaFin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $horaFin;
    /**
     * The horaInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $horaInicio;
    /**
     * The pago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pago;
    /**
     * The porcentaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $porcentaje;
    /**
     * The tipoHorasExtra
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipoHorasExtra;
    /**
     * Constructor method for HoraExtra
     * @uses HoraExtra::setCantidad()
     * @uses HoraExtra::setExtrasNom()
     * @uses HoraExtra::setHoraFin()
     * @uses HoraExtra::setHoraInicio()
     * @uses HoraExtra::setPago()
     * @uses HoraExtra::setPorcentaje()
     * @uses HoraExtra::setTipoHorasExtra()
     * @param string $cantidad
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $horaFin
     * @param string $horaInicio
     * @param string $pago
     * @param string $porcentaje
     * @param string $tipoHorasExtra
     */
    public function __construct($cantidad = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $horaFin = null, $horaInicio = null, $pago = null, $porcentaje = null, $tipoHorasExtra = null)
    {
        $this
            ->setCantidad($cantidad)
            ->setExtrasNom($extrasNom)
            ->setHoraFin($horaFin)
            ->setHoraInicio($horaInicio)
            ->setPago($pago)
            ->setPorcentaje($porcentaje)
            ->setTipoHorasExtra($tipoHorasExtra);
    }
    /**
     * Get cantidad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCantidad()
    {
        return isset($this->cantidad) ? $this->cantidad : null;
    }
    /**
     * Set cantidad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cantidad
     * @return \StructType\HoraExtra
     */
    public function setCantidad($cantidad = null)
    {
        // validation for constraint: string
        if (!is_null($cantidad) && !is_string($cantidad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cantidad, true), gettype($cantidad)), __LINE__);
        }
        if (is_null($cantidad) || (is_array($cantidad) && empty($cantidad))) {
            unset($this->cantidad);
        } else {
            $this->cantidad = $cantidad;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\HoraExtra
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get horaFin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHoraFin()
    {
        return isset($this->horaFin) ? $this->horaFin : null;
    }
    /**
     * Set horaFin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $horaFin
     * @return \StructType\HoraExtra
     */
    public function setHoraFin($horaFin = null)
    {
        // validation for constraint: string
        if (!is_null($horaFin) && !is_string($horaFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($horaFin, true), gettype($horaFin)), __LINE__);
        }
        if (is_null($horaFin) || (is_array($horaFin) && empty($horaFin))) {
            unset($this->horaFin);
        } else {
            $this->horaFin = $horaFin;
        }
        return $this;
    }
    /**
     * Get horaInicio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHoraInicio()
    {
        return isset($this->horaInicio) ? $this->horaInicio : null;
    }
    /**
     * Set horaInicio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $horaInicio
     * @return \StructType\HoraExtra
     */
    public function setHoraInicio($horaInicio = null)
    {
        // validation for constraint: string
        if (!is_null($horaInicio) && !is_string($horaInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($horaInicio, true), gettype($horaInicio)), __LINE__);
        }
        if (is_null($horaInicio) || (is_array($horaInicio) && empty($horaInicio))) {
            unset($this->horaInicio);
        } else {
            $this->horaInicio = $horaInicio;
        }
        return $this;
    }
    /**
     * Get pago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPago()
    {
        return isset($this->pago) ? $this->pago : null;
    }
    /**
     * Set pago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pago
     * @return \StructType\HoraExtra
     */
    public function setPago($pago = null)
    {
        // validation for constraint: string
        if (!is_null($pago) && !is_string($pago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pago, true), gettype($pago)), __LINE__);
        }
        if (is_null($pago) || (is_array($pago) && empty($pago))) {
            unset($this->pago);
        } else {
            $this->pago = $pago;
        }
        return $this;
    }
    /**
     * Get porcentaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPorcentaje()
    {
        return isset($this->porcentaje) ? $this->porcentaje : null;
    }
    /**
     * Set porcentaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $porcentaje
     * @return \StructType\HoraExtra
     */
    public function setPorcentaje($porcentaje = null)
    {
        // validation for constraint: string
        if (!is_null($porcentaje) && !is_string($porcentaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($porcentaje, true), gettype($porcentaje)), __LINE__);
        }
        if (is_null($porcentaje) || (is_array($porcentaje) && empty($porcentaje))) {
            unset($this->porcentaje);
        } else {
            $this->porcentaje = $porcentaje;
        }
        return $this;
    }
    /**
     * Get tipoHorasExtra value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoHorasExtra()
    {
        return isset($this->tipoHorasExtra) ? $this->tipoHorasExtra : null;
    }
    /**
     * Set tipoHorasExtra value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoHorasExtra
     * @return \StructType\HoraExtra
     */
    public function setTipoHorasExtra($tipoHorasExtra = null)
    {
        // validation for constraint: string
        if (!is_null($tipoHorasExtra) && !is_string($tipoHorasExtra)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoHorasExtra, true), gettype($tipoHorasExtra)), __LINE__);
        }
        if (is_null($tipoHorasExtra) || (is_array($tipoHorasExtra) && empty($tipoHorasExtra))) {
            unset($this->tipoHorasExtra);
        } else {
            $this->tipoHorasExtra = $tipoHorasExtra;
        }
        return $this;
    }
}
