<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Incapacidad StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Incapacidad
 * @subpackage Structs
 */
class Incapacidad extends AbstractStructBase
{
    /**
     * The cantidad
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cantidad;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The fechaFin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaFin;
    /**
     * The fechaInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaInicio;
    /**
     * The pago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pago;
    /**
     * The tipo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipo;
    /**
     * Constructor method for Incapacidad
     * @uses Incapacidad::setCantidad()
     * @uses Incapacidad::setExtrasNom()
     * @uses Incapacidad::setFechaFin()
     * @uses Incapacidad::setFechaInicio()
     * @uses Incapacidad::setPago()
     * @uses Incapacidad::setTipo()
     * @param string $cantidad
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $fechaFin
     * @param string $fechaInicio
     * @param string $pago
     * @param string $tipo
     */
    public function __construct($cantidad = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $fechaFin = null, $fechaInicio = null, $pago = null, $tipo = null)
    {
        $this
            ->setCantidad($cantidad)
            ->setExtrasNom($extrasNom)
            ->setFechaFin($fechaFin)
            ->setFechaInicio($fechaInicio)
            ->setPago($pago)
            ->setTipo($tipo);
    }
    /**
     * Get cantidad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCantidad()
    {
        return isset($this->cantidad) ? $this->cantidad : null;
    }
    /**
     * Set cantidad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cantidad
     * @return \StructType\Incapacidad
     */
    public function setCantidad($cantidad = null)
    {
        // validation for constraint: string
        if (!is_null($cantidad) && !is_string($cantidad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cantidad, true), gettype($cantidad)), __LINE__);
        }
        if (is_null($cantidad) || (is_array($cantidad) && empty($cantidad))) {
            unset($this->cantidad);
        } else {
            $this->cantidad = $cantidad;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Incapacidad
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get fechaFin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaFin()
    {
        return isset($this->fechaFin) ? $this->fechaFin : null;
    }
    /**
     * Set fechaFin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaFin
     * @return \StructType\Incapacidad
     */
    public function setFechaFin($fechaFin = null)
    {
        // validation for constraint: string
        if (!is_null($fechaFin) && !is_string($fechaFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaFin, true), gettype($fechaFin)), __LINE__);
        }
        if (is_null($fechaFin) || (is_array($fechaFin) && empty($fechaFin))) {
            unset($this->fechaFin);
        } else {
            $this->fechaFin = $fechaFin;
        }
        return $this;
    }
    /**
     * Get fechaInicio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaInicio()
    {
        return isset($this->fechaInicio) ? $this->fechaInicio : null;
    }
    /**
     * Set fechaInicio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaInicio
     * @return \StructType\Incapacidad
     */
    public function setFechaInicio($fechaInicio = null)
    {
        // validation for constraint: string
        if (!is_null($fechaInicio) && !is_string($fechaInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaInicio, true), gettype($fechaInicio)), __LINE__);
        }
        if (is_null($fechaInicio) || (is_array($fechaInicio) && empty($fechaInicio))) {
            unset($this->fechaInicio);
        } else {
            $this->fechaInicio = $fechaInicio;
        }
        return $this;
    }
    /**
     * Get pago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPago()
    {
        return isset($this->pago) ? $this->pago : null;
    }
    /**
     * Set pago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pago
     * @return \StructType\Incapacidad
     */
    public function setPago($pago = null)
    {
        // validation for constraint: string
        if (!is_null($pago) && !is_string($pago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pago, true), gettype($pago)), __LINE__);
        }
        if (is_null($pago) || (is_array($pago) && empty($pago))) {
            unset($this->pago);
        } else {
            $this->pago = $pago;
        }
        return $this;
    }
    /**
     * Get tipo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipo()
    {
        return isset($this->tipo) ? $this->tipo : null;
    }
    /**
     * Set tipo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipo
     * @return \StructType\Incapacidad
     */
    public function setTipo($tipo = null)
    {
        // validation for constraint: string
        if (!is_null($tipo) && !is_string($tipo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipo, true), gettype($tipo)), __LINE__);
        }
        if (is_null($tipo) || (is_array($tipo) && empty($tipo))) {
            unset($this->tipo);
        } else {
            $this->tipo = $tipo;
        }
        return $this;
    }
}
