<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Libranza StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Libranza
 * @subpackage Structs
 */
class Libranza extends AbstractStructBase
{
    /**
     * The deduccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $deduccion;
    /**
     * The descripcion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $descripcion;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * Constructor method for Libranza
     * @uses Libranza::setDeduccion()
     * @uses Libranza::setDescripcion()
     * @uses Libranza::setExtrasNom()
     * @param string $deduccion
     * @param string $descripcion
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     */
    public function __construct($deduccion = null, $descripcion = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        $this
            ->setDeduccion($deduccion)
            ->setDescripcion($descripcion)
            ->setExtrasNom($extrasNom);
    }
    /**
     * Get deduccion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeduccion()
    {
        return isset($this->deduccion) ? $this->deduccion : null;
    }
    /**
     * Set deduccion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deduccion
     * @return \StructType\Libranza
     */
    public function setDeduccion($deduccion = null)
    {
        // validation for constraint: string
        if (!is_null($deduccion) && !is_string($deduccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deduccion, true), gettype($deduccion)), __LINE__);
        }
        if (is_null($deduccion) || (is_array($deduccion) && empty($deduccion))) {
            unset($this->deduccion);
        } else {
            $this->deduccion = $deduccion;
        }
        return $this;
    }
    /**
     * Get descripcion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescripcion()
    {
        return isset($this->descripcion) ? $this->descripcion : null;
    }
    /**
     * Set descripcion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descripcion
     * @return \StructType\Libranza
     */
    public function setDescripcion($descripcion = null)
    {
        // validation for constraint: string
        if (!is_null($descripcion) && !is_string($descripcion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descripcion, true), gettype($descripcion)), __LINE__);
        }
        if (is_null($descripcion) || (is_array($descripcion) && empty($descripcion))) {
            unset($this->descripcion);
        } else {
            $this->descripcion = $descripcion;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Libranza
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
}
