<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LugarGeneracionXML StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:LugarGeneracionXML
 * @subpackage Structs
 */
class LugarGeneracionXML extends AbstractStructBase
{
    /**
     * The departamentoEstado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $departamentoEstado;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The idioma
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idioma;
    /**
     * The municipioCiudad
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $municipioCiudad;
    /**
     * The pais
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pais;
    /**
     * Constructor method for LugarGeneracionXML
     * @uses LugarGeneracionXML::setDepartamentoEstado()
     * @uses LugarGeneracionXML::setExtrasNom()
     * @uses LugarGeneracionXML::setIdioma()
     * @uses LugarGeneracionXML::setMunicipioCiudad()
     * @uses LugarGeneracionXML::setPais()
     * @param string $departamentoEstado
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $idioma
     * @param string $municipioCiudad
     * @param string $pais
     */
    public function __construct($departamentoEstado = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $idioma = null, $municipioCiudad = null, $pais = null)
    {
        $this
            ->setDepartamentoEstado($departamentoEstado)
            ->setExtrasNom($extrasNom)
            ->setIdioma($idioma)
            ->setMunicipioCiudad($municipioCiudad)
            ->setPais($pais);
    }
    /**
     * Get departamentoEstado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDepartamentoEstado()
    {
        return isset($this->departamentoEstado) ? $this->departamentoEstado : null;
    }
    /**
     * Set departamentoEstado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $departamentoEstado
     * @return \StructType\LugarGeneracionXML
     */
    public function setDepartamentoEstado($departamentoEstado = null)
    {
        // validation for constraint: string
        if (!is_null($departamentoEstado) && !is_string($departamentoEstado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($departamentoEstado, true), gettype($departamentoEstado)), __LINE__);
        }
        if (is_null($departamentoEstado) || (is_array($departamentoEstado) && empty($departamentoEstado))) {
            unset($this->departamentoEstado);
        } else {
            $this->departamentoEstado = $departamentoEstado;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\LugarGeneracionXML
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get idioma value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdioma()
    {
        return isset($this->idioma) ? $this->idioma : null;
    }
    /**
     * Set idioma value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idioma
     * @return \StructType\LugarGeneracionXML
     */
    public function setIdioma($idioma = null)
    {
        // validation for constraint: string
        if (!is_null($idioma) && !is_string($idioma)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idioma, true), gettype($idioma)), __LINE__);
        }
        if (is_null($idioma) || (is_array($idioma) && empty($idioma))) {
            unset($this->idioma);
        } else {
            $this->idioma = $idioma;
        }
        return $this;
    }
    /**
     * Get municipioCiudad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMunicipioCiudad()
    {
        return isset($this->municipioCiudad) ? $this->municipioCiudad : null;
    }
    /**
     * Set municipioCiudad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $municipioCiudad
     * @return \StructType\LugarGeneracionXML
     */
    public function setMunicipioCiudad($municipioCiudad = null)
    {
        // validation for constraint: string
        if (!is_null($municipioCiudad) && !is_string($municipioCiudad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($municipioCiudad, true), gettype($municipioCiudad)), __LINE__);
        }
        if (is_null($municipioCiudad) || (is_array($municipioCiudad) && empty($municipioCiudad))) {
            unset($this->municipioCiudad);
        } else {
            $this->municipioCiudad = $municipioCiudad;
        }
        return $this;
    }
    /**
     * Get pais value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPais()
    {
        return isset($this->pais) ? $this->pais : null;
    }
    /**
     * Set pais value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pais
     * @return \StructType\LugarGeneracionXML
     */
    public function setPais($pais = null)
    {
        // validation for constraint: string
        if (!is_null($pais) && !is_string($pais)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pais, true), gettype($pais)), __LINE__);
        }
        if (is_null($pais) || (is_array($pais) && empty($pais))) {
            unset($this->pais);
        } else {
            $this->pais = $pais;
        }
        return $this;
    }
}
