<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OtroConcepto StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OtroConcepto
 * @subpackage Structs
 */
class OtroConcepto extends AbstractStructBase
{
    /**
     * The conceptoNS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $conceptoNS;
    /**
     * The conceptoS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $conceptoS;
    /**
     * The descripcionConcepto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $descripcionConcepto;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * Constructor method for OtroConcepto
     * @uses OtroConcepto::setConceptoNS()
     * @uses OtroConcepto::setConceptoS()
     * @uses OtroConcepto::setDescripcionConcepto()
     * @uses OtroConcepto::setExtrasNom()
     * @param string $conceptoNS
     * @param string $conceptoS
     * @param string $descripcionConcepto
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     */
    public function __construct($conceptoNS = null, $conceptoS = null, $descripcionConcepto = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        $this
            ->setConceptoNS($conceptoNS)
            ->setConceptoS($conceptoS)
            ->setDescripcionConcepto($descripcionConcepto)
            ->setExtrasNom($extrasNom);
    }
    /**
     * Get conceptoNS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConceptoNS()
    {
        return isset($this->conceptoNS) ? $this->conceptoNS : null;
    }
    /**
     * Set conceptoNS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $conceptoNS
     * @return \StructType\OtroConcepto
     */
    public function setConceptoNS($conceptoNS = null)
    {
        // validation for constraint: string
        if (!is_null($conceptoNS) && !is_string($conceptoNS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($conceptoNS, true), gettype($conceptoNS)), __LINE__);
        }
        if (is_null($conceptoNS) || (is_array($conceptoNS) && empty($conceptoNS))) {
            unset($this->conceptoNS);
        } else {
            $this->conceptoNS = $conceptoNS;
        }
        return $this;
    }
    /**
     * Get conceptoS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConceptoS()
    {
        return isset($this->conceptoS) ? $this->conceptoS : null;
    }
    /**
     * Set conceptoS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $conceptoS
     * @return \StructType\OtroConcepto
     */
    public function setConceptoS($conceptoS = null)
    {
        // validation for constraint: string
        if (!is_null($conceptoS) && !is_string($conceptoS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($conceptoS, true), gettype($conceptoS)), __LINE__);
        }
        if (is_null($conceptoS) || (is_array($conceptoS) && empty($conceptoS))) {
            unset($this->conceptoS);
        } else {
            $this->conceptoS = $conceptoS;
        }
        return $this;
    }
    /**
     * Get descripcionConcepto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescripcionConcepto()
    {
        return isset($this->descripcionConcepto) ? $this->descripcionConcepto : null;
    }
    /**
     * Set descripcionConcepto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descripcionConcepto
     * @return \StructType\OtroConcepto
     */
    public function setDescripcionConcepto($descripcionConcepto = null)
    {
        // validation for constraint: string
        if (!is_null($descripcionConcepto) && !is_string($descripcionConcepto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descripcionConcepto, true), gettype($descripcionConcepto)), __LINE__);
        }
        if (is_null($descripcionConcepto) || (is_array($descripcionConcepto) && empty($descripcionConcepto))) {
            unset($this->descripcionConcepto);
        } else {
            $this->descripcionConcepto = $descripcionConcepto;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\OtroConcepto
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
}
