<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Pago StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Pago
 * @subpackage Structs
 */
class Pago extends AbstractStructBase
{
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The fechasPagos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFechaPago
     */
    public $fechasPagos;
    /**
     * The medioPago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $medioPago;
    /**
     * The metodoDePago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $metodoDePago;
    /**
     * The nombreBanco
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nombreBanco;
    /**
     * The numeroCuenta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numeroCuenta;
    /**
     * The tipoCuenta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipoCuenta;
    /**
     * Constructor method for Pago
     * @uses Pago::setExtrasNom()
     * @uses Pago::setFechasPagos()
     * @uses Pago::setMedioPago()
     * @uses Pago::setMetodoDePago()
     * @uses Pago::setNombreBanco()
     * @uses Pago::setNumeroCuenta()
     * @uses Pago::setTipoCuenta()
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param \ArrayType\ArrayOfFechaPago $fechasPagos
     * @param string $medioPago
     * @param string $metodoDePago
     * @param string $nombreBanco
     * @param string $numeroCuenta
     * @param string $tipoCuenta
     */
    public function __construct(\ArrayType\ArrayOfExtensibleNom $extrasNom = null, \ArrayType\ArrayOfFechaPago $fechasPagos = null, $medioPago = null, $metodoDePago = null, $nombreBanco = null, $numeroCuenta = null, $tipoCuenta = null)
    {
        $this
            ->setExtrasNom($extrasNom)
            ->setFechasPagos($fechasPagos)
            ->setMedioPago($medioPago)
            ->setMetodoDePago($metodoDePago)
            ->setNombreBanco($nombreBanco)
            ->setNumeroCuenta($numeroCuenta)
            ->setTipoCuenta($tipoCuenta);
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Pago
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get fechasPagos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFechaPago|null
     */
    public function getFechasPagos()
    {
        return isset($this->fechasPagos) ? $this->fechasPagos : null;
    }
    /**
     * Set fechasPagos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFechaPago $fechasPagos
     * @return \StructType\Pago
     */
    public function setFechasPagos(\ArrayType\ArrayOfFechaPago $fechasPagos = null)
    {
        if (is_null($fechasPagos) || (is_array($fechasPagos) && empty($fechasPagos))) {
            unset($this->fechasPagos);
        } else {
            $this->fechasPagos = $fechasPagos;
        }
        return $this;
    }
    /**
     * Get medioPago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMedioPago()
    {
        return isset($this->medioPago) ? $this->medioPago : null;
    }
    /**
     * Set medioPago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $medioPago
     * @return \StructType\Pago
     */
    public function setMedioPago($medioPago = null)
    {
        // validation for constraint: string
        if (!is_null($medioPago) && !is_string($medioPago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($medioPago, true), gettype($medioPago)), __LINE__);
        }
        if (is_null($medioPago) || (is_array($medioPago) && empty($medioPago))) {
            unset($this->medioPago);
        } else {
            $this->medioPago = $medioPago;
        }
        return $this;
    }
    /**
     * Get metodoDePago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMetodoDePago()
    {
        return isset($this->metodoDePago) ? $this->metodoDePago : null;
    }
    /**
     * Set metodoDePago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $metodoDePago
     * @return \StructType\Pago
     */
    public function setMetodoDePago($metodoDePago = null)
    {
        // validation for constraint: string
        if (!is_null($metodoDePago) && !is_string($metodoDePago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($metodoDePago, true), gettype($metodoDePago)), __LINE__);
        }
        if (is_null($metodoDePago) || (is_array($metodoDePago) && empty($metodoDePago))) {
            unset($this->metodoDePago);
        } else {
            $this->metodoDePago = $metodoDePago;
        }
        return $this;
    }
    /**
     * Get nombreBanco value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombreBanco()
    {
        return isset($this->nombreBanco) ? $this->nombreBanco : null;
    }
    /**
     * Set nombreBanco value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombreBanco
     * @return \StructType\Pago
     */
    public function setNombreBanco($nombreBanco = null)
    {
        // validation for constraint: string
        if (!is_null($nombreBanco) && !is_string($nombreBanco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombreBanco, true), gettype($nombreBanco)), __LINE__);
        }
        if (is_null($nombreBanco) || (is_array($nombreBanco) && empty($nombreBanco))) {
            unset($this->nombreBanco);
        } else {
            $this->nombreBanco = $nombreBanco;
        }
        return $this;
    }
    /**
     * Get numeroCuenta value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroCuenta()
    {
        return isset($this->numeroCuenta) ? $this->numeroCuenta : null;
    }
    /**
     * Set numeroCuenta value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroCuenta
     * @return \StructType\Pago
     */
    public function setNumeroCuenta($numeroCuenta = null)
    {
        // validation for constraint: string
        if (!is_null($numeroCuenta) && !is_string($numeroCuenta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroCuenta, true), gettype($numeroCuenta)), __LINE__);
        }
        if (is_null($numeroCuenta) || (is_array($numeroCuenta) && empty($numeroCuenta))) {
            unset($this->numeroCuenta);
        } else {
            $this->numeroCuenta = $numeroCuenta;
        }
        return $this;
    }
    /**
     * Get tipoCuenta value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoCuenta()
    {
        return isset($this->tipoCuenta) ? $this->tipoCuenta : null;
    }
    /**
     * Set tipoCuenta value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoCuenta
     * @return \StructType\Pago
     */
    public function setTipoCuenta($tipoCuenta = null)
    {
        // validation for constraint: string
        if (!is_null($tipoCuenta) && !is_string($tipoCuenta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoCuenta, true), gettype($tipoCuenta)), __LINE__);
        }
        if (is_null($tipoCuenta) || (is_array($tipoCuenta) && empty($tipoCuenta))) {
            unset($this->tipoCuenta);
        } else {
            $this->tipoCuenta = $tipoCuenta;
        }
        return $this;
    }
}
