<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Periodo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Periodo
 * @subpackage Structs
 */
class Periodo extends AbstractStructBase
{
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The fechaIngreso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaIngreso;
    /**
     * The fechaLiquidacionFin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaLiquidacionFin;
    /**
     * The fechaLiquidacionInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaLiquidacionInicio;
    /**
     * The fechaRetiro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fechaRetiro;
    /**
     * The tiempoLaborado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tiempoLaborado;
    /**
     * Constructor method for Periodo
     * @uses Periodo::setExtrasNom()
     * @uses Periodo::setFechaIngreso()
     * @uses Periodo::setFechaLiquidacionFin()
     * @uses Periodo::setFechaLiquidacionInicio()
     * @uses Periodo::setFechaRetiro()
     * @uses Periodo::setTiempoLaborado()
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $fechaIngreso
     * @param string $fechaLiquidacionFin
     * @param string $fechaLiquidacionInicio
     * @param string $fechaRetiro
     * @param string $tiempoLaborado
     */
    public function __construct(\ArrayType\ArrayOfExtensibleNom $extrasNom = null, $fechaIngreso = null, $fechaLiquidacionFin = null, $fechaLiquidacionInicio = null, $fechaRetiro = null, $tiempoLaborado = null)
    {
        $this
            ->setExtrasNom($extrasNom)
            ->setFechaIngreso($fechaIngreso)
            ->setFechaLiquidacionFin($fechaLiquidacionFin)
            ->setFechaLiquidacionInicio($fechaLiquidacionInicio)
            ->setFechaRetiro($fechaRetiro)
            ->setTiempoLaborado($tiempoLaborado);
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Periodo
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get fechaIngreso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaIngreso()
    {
        return isset($this->fechaIngreso) ? $this->fechaIngreso : null;
    }
    /**
     * Set fechaIngreso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaIngreso
     * @return \StructType\Periodo
     */
    public function setFechaIngreso($fechaIngreso = null)
    {
        // validation for constraint: string
        if (!is_null($fechaIngreso) && !is_string($fechaIngreso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaIngreso, true), gettype($fechaIngreso)), __LINE__);
        }
        if (is_null($fechaIngreso) || (is_array($fechaIngreso) && empty($fechaIngreso))) {
            unset($this->fechaIngreso);
        } else {
            $this->fechaIngreso = $fechaIngreso;
        }
        return $this;
    }
    /**
     * Get fechaLiquidacionFin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaLiquidacionFin()
    {
        return isset($this->fechaLiquidacionFin) ? $this->fechaLiquidacionFin : null;
    }
    /**
     * Set fechaLiquidacionFin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaLiquidacionFin
     * @return \StructType\Periodo
     */
    public function setFechaLiquidacionFin($fechaLiquidacionFin = null)
    {
        // validation for constraint: string
        if (!is_null($fechaLiquidacionFin) && !is_string($fechaLiquidacionFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaLiquidacionFin, true), gettype($fechaLiquidacionFin)), __LINE__);
        }
        if (is_null($fechaLiquidacionFin) || (is_array($fechaLiquidacionFin) && empty($fechaLiquidacionFin))) {
            unset($this->fechaLiquidacionFin);
        } else {
            $this->fechaLiquidacionFin = $fechaLiquidacionFin;
        }
        return $this;
    }
    /**
     * Get fechaLiquidacionInicio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaLiquidacionInicio()
    {
        return isset($this->fechaLiquidacionInicio) ? $this->fechaLiquidacionInicio : null;
    }
    /**
     * Set fechaLiquidacionInicio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaLiquidacionInicio
     * @return \StructType\Periodo
     */
    public function setFechaLiquidacionInicio($fechaLiquidacionInicio = null)
    {
        // validation for constraint: string
        if (!is_null($fechaLiquidacionInicio) && !is_string($fechaLiquidacionInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaLiquidacionInicio, true), gettype($fechaLiquidacionInicio)), __LINE__);
        }
        if (is_null($fechaLiquidacionInicio) || (is_array($fechaLiquidacionInicio) && empty($fechaLiquidacionInicio))) {
            unset($this->fechaLiquidacionInicio);
        } else {
            $this->fechaLiquidacionInicio = $fechaLiquidacionInicio;
        }
        return $this;
    }
    /**
     * Get fechaRetiro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFechaRetiro()
    {
        return isset($this->fechaRetiro) ? $this->fechaRetiro : null;
    }
    /**
     * Set fechaRetiro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fechaRetiro
     * @return \StructType\Periodo
     */
    public function setFechaRetiro($fechaRetiro = null)
    {
        // validation for constraint: string
        if (!is_null($fechaRetiro) && !is_string($fechaRetiro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaRetiro, true), gettype($fechaRetiro)), __LINE__);
        }
        if (is_null($fechaRetiro) || (is_array($fechaRetiro) && empty($fechaRetiro))) {
            unset($this->fechaRetiro);
        } else {
            $this->fechaRetiro = $fechaRetiro;
        }
        return $this;
    }
    /**
     * Get tiempoLaborado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTiempoLaborado()
    {
        return isset($this->tiempoLaborado) ? $this->tiempoLaborado : null;
    }
    /**
     * Set tiempoLaborado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tiempoLaborado
     * @return \StructType\Periodo
     */
    public function setTiempoLaborado($tiempoLaborado = null)
    {
        // validation for constraint: string
        if (!is_null($tiempoLaborado) && !is_string($tiempoLaborado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tiempoLaborado, true), gettype($tiempoLaborado)), __LINE__);
        }
        if (is_null($tiempoLaborado) || (is_array($tiempoLaborado) && empty($tiempoLaborado))) {
            unset($this->tiempoLaborado);
        } else {
            $this->tiempoLaborado = $tiempoLaborado;
        }
        return $this;
    }
}
