<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Prima StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Prima
 * @subpackage Structs
 */
class Prima extends AbstractStructBase
{
    /**
     * The cantidad
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cantidad;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The pago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pago;
    /**
     * The pagoNS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pagoNS;
    /**
     * Constructor method for Prima
     * @uses Prima::setCantidad()
     * @uses Prima::setExtrasNom()
     * @uses Prima::setPago()
     * @uses Prima::setPagoNS()
     * @param string $cantidad
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $pago
     * @param string $pagoNS
     */
    public function __construct($cantidad = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $pago = null, $pagoNS = null)
    {
        $this
            ->setCantidad($cantidad)
            ->setExtrasNom($extrasNom)
            ->setPago($pago)
            ->setPagoNS($pagoNS);
    }
    /**
     * Get cantidad value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCantidad()
    {
        return isset($this->cantidad) ? $this->cantidad : null;
    }
    /**
     * Set cantidad value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cantidad
     * @return \StructType\Prima
     */
    public function setCantidad($cantidad = null)
    {
        // validation for constraint: string
        if (!is_null($cantidad) && !is_string($cantidad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cantidad, true), gettype($cantidad)), __LINE__);
        }
        if (is_null($cantidad) || (is_array($cantidad) && empty($cantidad))) {
            unset($this->cantidad);
        } else {
            $this->cantidad = $cantidad;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Prima
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get pago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPago()
    {
        return isset($this->pago) ? $this->pago : null;
    }
    /**
     * Set pago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pago
     * @return \StructType\Prima
     */
    public function setPago($pago = null)
    {
        // validation for constraint: string
        if (!is_null($pago) && !is_string($pago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pago, true), gettype($pago)), __LINE__);
        }
        if (is_null($pago) || (is_array($pago) && empty($pago))) {
            unset($this->pago);
        } else {
            $this->pago = $pago;
        }
        return $this;
    }
    /**
     * Get pagoNS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPagoNS()
    {
        return isset($this->pagoNS) ? $this->pagoNS : null;
    }
    /**
     * Set pagoNS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pagoNS
     * @return \StructType\Prima
     */
    public function setPagoNS($pagoNS = null)
    {
        // validation for constraint: string
        if (!is_null($pagoNS) && !is_string($pagoNS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pagoNS, true), gettype($pagoNS)), __LINE__);
        }
        if (is_null($pagoNS) || (is_array($pagoNS) && empty($pagoNS))) {
            unset($this->pagoNS);
        } else {
            $this->pagoNS = $pagoNS;
        }
        return $this;
    }
}
