<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Request StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Request
 * @subpackage Structs
 */
class Request extends AbstractStructBase
{
    /**
     * The idSoftware
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idSoftware;
    /**
     * The nitEmpleador
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nitEmpleador;
    /**
     * The nomina
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NominaGeneral
     */
    public $nomina;
    /**
     * The tokenEnterprise
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tokenEnterprise;
    /**
     * The tokenPassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tokenPassword;
    /**
     * Constructor method for Request
     * @uses Request::setIdSoftware()
     * @uses Request::setNitEmpleador()
     * @uses Request::setNomina()
     * @uses Request::setTokenEnterprise()
     * @uses Request::setTokenPassword()
     * @param string $idSoftware
     * @param string $nitEmpleador
     * @param \StructType\NominaGeneral $nomina
     * @param string $tokenEnterprise
     * @param string $tokenPassword
     */
    public function __construct($idSoftware = null, $nitEmpleador = null, \StructType\NominaGeneral $nomina = null, $tokenEnterprise = null, $tokenPassword = null)
    {
        $this
            ->setIdSoftware($idSoftware)
            ->setNitEmpleador($nitEmpleador)
            ->setNomina($nomina)
            ->setTokenEnterprise($tokenEnterprise)
            ->setTokenPassword($tokenPassword);
    }
    /**
     * Get idSoftware value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdSoftware()
    {
        return isset($this->idSoftware) ? $this->idSoftware : null;
    }
    /**
     * Set idSoftware value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idSoftware
     * @return \StructType\Request
     */
    public function setIdSoftware($idSoftware = null)
    {
        // validation for constraint: string
        if (!is_null($idSoftware) && !is_string($idSoftware)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idSoftware, true), gettype($idSoftware)), __LINE__);
        }
        if (is_null($idSoftware) || (is_array($idSoftware) && empty($idSoftware))) {
            unset($this->idSoftware);
        } else {
            $this->idSoftware = $idSoftware;
        }
        return $this;
    }
    /**
     * Get nitEmpleador value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNitEmpleador()
    {
        return isset($this->nitEmpleador) ? $this->nitEmpleador : null;
    }
    /**
     * Set nitEmpleador value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nitEmpleador
     * @return \StructType\Request
     */
    public function setNitEmpleador($nitEmpleador = null)
    {
        // validation for constraint: string
        if (!is_null($nitEmpleador) && !is_string($nitEmpleador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nitEmpleador, true), gettype($nitEmpleador)), __LINE__);
        }
        if (is_null($nitEmpleador) || (is_array($nitEmpleador) && empty($nitEmpleador))) {
            unset($this->nitEmpleador);
        } else {
            $this->nitEmpleador = $nitEmpleador;
        }
        return $this;
    }
    /**
     * Get nomina value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NominaGeneral|null
     */
    public function getNomina()
    {
        return isset($this->nomina) ? $this->nomina : null;
    }
    /**
     * Set nomina value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\NominaGeneral $nomina
     * @return \StructType\Request
     */
    public function setNomina(\StructType\NominaGeneral $nomina = null)
    {
        if (is_null($nomina) || (is_array($nomina) && empty($nomina))) {
            unset($this->nomina);
        } else {
            $this->nomina = $nomina;
        }
        return $this;
    }
    /**
     * Get tokenEnterprise value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTokenEnterprise()
    {
        return isset($this->tokenEnterprise) ? $this->tokenEnterprise : null;
    }
    /**
     * Set tokenEnterprise value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tokenEnterprise
     * @return \StructType\Request
     */
    public function setTokenEnterprise($tokenEnterprise = null)
    {
        // validation for constraint: string
        if (!is_null($tokenEnterprise) && !is_string($tokenEnterprise)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tokenEnterprise, true), gettype($tokenEnterprise)), __LINE__);
        }
        if (is_null($tokenEnterprise) || (is_array($tokenEnterprise) && empty($tokenEnterprise))) {
            unset($this->tokenEnterprise);
        } else {
            $this->tokenEnterprise = $tokenEnterprise;
        }
        return $this;
    }
    /**
     * Get tokenPassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTokenPassword()
    {
        return isset($this->tokenPassword) ? $this->tokenPassword : null;
    }
    /**
     * Set tokenPassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tokenPassword
     * @return \StructType\Request
     */
    public function setTokenPassword($tokenPassword = null)
    {
        // validation for constraint: string
        if (!is_null($tokenPassword) && !is_string($tokenPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tokenPassword, true), gettype($tokenPassword)), __LINE__);
        }
        if (is_null($tokenPassword) || (is_array($tokenPassword) && empty($tokenPassword))) {
            unset($this->tokenPassword);
        } else {
            $this->tokenPassword = $tokenPassword;
        }
        return $this;
    }
}
