<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Response StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Response
 * @subpackage Structs
 */
class Response extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codigo;
    /**
     * The consecutivoDocumento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $consecutivoDocumento;
    /**
     * The cune
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cune;
    /**
     * The esvalidoDIAN
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $esvalidoDIAN;
    /**
     * The idSoftware
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idSoftware;
    /**
     * The mensaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensaje;
    /**
     * The nitEmpleado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nitEmpleado;
    /**
     * The nitEmpleador
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nitEmpleador;
    /**
     * The qr
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $qr;
    /**
     * The reglasNotificacionesDIAN
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $reglasNotificacionesDIAN;
    /**
     * The reglasNotificacionesTFHKA
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $reglasNotificacionesTFHKA;
    /**
     * The reglasRechazoDIAN
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $reglasRechazoDIAN;
    /**
     * The reglasRechazoTFHKA
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $reglasRechazoTFHKA;
    /**
     * The resultado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $resultado;
    /**
     * The trackId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $trackId;
    /**
     * The xml
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $xml;
    /**
     * Constructor method for Response
     * @uses Response::setCodigo()
     * @uses Response::setConsecutivoDocumento()
     * @uses Response::setCune()
     * @uses Response::setEsvalidoDIAN()
     * @uses Response::setIdSoftware()
     * @uses Response::setMensaje()
     * @uses Response::setNitEmpleado()
     * @uses Response::setNitEmpleador()
     * @uses Response::setQr()
     * @uses Response::setReglasNotificacionesDIAN()
     * @uses Response::setReglasNotificacionesTFHKA()
     * @uses Response::setReglasRechazoDIAN()
     * @uses Response::setReglasRechazoTFHKA()
     * @uses Response::setResultado()
     * @uses Response::setTrackId()
     * @uses Response::setXml()
     * @param string $codigo
     * @param string $consecutivoDocumento
     * @param string $cune
     * @param bool $esvalidoDIAN
     * @param string $idSoftware
     * @param string $mensaje
     * @param string $nitEmpleado
     * @param string $nitEmpleador
     * @param string $qr
     * @param \ArrayType\ArrayOfstring $reglasNotificacionesDIAN
     * @param \ArrayType\ArrayOfstring $reglasNotificacionesTFHKA
     * @param \ArrayType\ArrayOfstring $reglasRechazoDIAN
     * @param \ArrayType\ArrayOfstring $reglasRechazoTFHKA
     * @param string $resultado
     * @param string $trackId
     * @param string $xml
     */
    public function __construct($codigo = null, $consecutivoDocumento = null, $cune = null, $esvalidoDIAN = null, $idSoftware = null, $mensaje = null, $nitEmpleado = null, $nitEmpleador = null, $qr = null, \ArrayType\ArrayOfstring $reglasNotificacionesDIAN = null, \ArrayType\ArrayOfstring $reglasNotificacionesTFHKA = null, \ArrayType\ArrayOfstring $reglasRechazoDIAN = null, \ArrayType\ArrayOfstring $reglasRechazoTFHKA = null, $resultado = null, $trackId = null, $xml = null)
    {
        $this
            ->setCodigo($codigo)
            ->setConsecutivoDocumento($consecutivoDocumento)
            ->setCune($cune)
            ->setEsvalidoDIAN($esvalidoDIAN)
            ->setIdSoftware($idSoftware)
            ->setMensaje($mensaje)
            ->setNitEmpleado($nitEmpleado)
            ->setNitEmpleador($nitEmpleador)
            ->setQr($qr)
            ->setReglasNotificacionesDIAN($reglasNotificacionesDIAN)
            ->setReglasNotificacionesTFHKA($reglasNotificacionesTFHKA)
            ->setReglasRechazoDIAN($reglasRechazoDIAN)
            ->setReglasRechazoTFHKA($reglasRechazoTFHKA)
            ->setResultado($resultado)
            ->setTrackId($trackId)
            ->setXml($xml);
    }
    /**
     * Get codigo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigo()
    {
        return isset($this->codigo) ? $this->codigo : null;
    }
    /**
     * Set codigo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigo
     * @return \StructType\Response
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: string
        if (!is_null($codigo) && !is_string($codigo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        if (is_null($codigo) || (is_array($codigo) && empty($codigo))) {
            unset($this->codigo);
        } else {
            $this->codigo = $codigo;
        }
        return $this;
    }
    /**
     * Get consecutivoDocumento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getConsecutivoDocumento()
    {
        return isset($this->consecutivoDocumento) ? $this->consecutivoDocumento : null;
    }
    /**
     * Set consecutivoDocumento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $consecutivoDocumento
     * @return \StructType\Response
     */
    public function setConsecutivoDocumento($consecutivoDocumento = null)
    {
        // validation for constraint: string
        if (!is_null($consecutivoDocumento) && !is_string($consecutivoDocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($consecutivoDocumento, true), gettype($consecutivoDocumento)), __LINE__);
        }
        if (is_null($consecutivoDocumento) || (is_array($consecutivoDocumento) && empty($consecutivoDocumento))) {
            unset($this->consecutivoDocumento);
        } else {
            $this->consecutivoDocumento = $consecutivoDocumento;
        }
        return $this;
    }
    /**
     * Get cune value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCune()
    {
        return isset($this->cune) ? $this->cune : null;
    }
    /**
     * Set cune value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cune
     * @return \StructType\Response
     */
    public function setCune($cune = null)
    {
        // validation for constraint: string
        if (!is_null($cune) && !is_string($cune)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cune, true), gettype($cune)), __LINE__);
        }
        if (is_null($cune) || (is_array($cune) && empty($cune))) {
            unset($this->cune);
        } else {
            $this->cune = $cune;
        }
        return $this;
    }
    /**
     * Get esvalidoDIAN value
     * @return bool|null
     */
    public function getEsvalidoDIAN()
    {
        return $this->esvalidoDIAN;
    }
    /**
     * Set esvalidoDIAN value
     * @param bool $esvalidoDIAN
     * @return \StructType\Response
     */
    public function setEsvalidoDIAN($esvalidoDIAN = null)
    {
        // validation for constraint: boolean
        if (!is_null($esvalidoDIAN) && !is_bool($esvalidoDIAN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($esvalidoDIAN, true), gettype($esvalidoDIAN)), __LINE__);
        }
        $this->esvalidoDIAN = $esvalidoDIAN;
        return $this;
    }
    /**
     * Get idSoftware value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdSoftware()
    {
        return isset($this->idSoftware) ? $this->idSoftware : null;
    }
    /**
     * Set idSoftware value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idSoftware
     * @return \StructType\Response
     */
    public function setIdSoftware($idSoftware = null)
    {
        // validation for constraint: string
        if (!is_null($idSoftware) && !is_string($idSoftware)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idSoftware, true), gettype($idSoftware)), __LINE__);
        }
        if (is_null($idSoftware) || (is_array($idSoftware) && empty($idSoftware))) {
            unset($this->idSoftware);
        } else {
            $this->idSoftware = $idSoftware;
        }
        return $this;
    }
    /**
     * Get mensaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensaje()
    {
        return isset($this->mensaje) ? $this->mensaje : null;
    }
    /**
     * Set mensaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensaje
     * @return \StructType\Response
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensaje, true), gettype($mensaje)), __LINE__);
        }
        if (is_null($mensaje) || (is_array($mensaje) && empty($mensaje))) {
            unset($this->mensaje);
        } else {
            $this->mensaje = $mensaje;
        }
        return $this;
    }
    /**
     * Get nitEmpleado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNitEmpleado()
    {
        return isset($this->nitEmpleado) ? $this->nitEmpleado : null;
    }
    /**
     * Set nitEmpleado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nitEmpleado
     * @return \StructType\Response
     */
    public function setNitEmpleado($nitEmpleado = null)
    {
        // validation for constraint: string
        if (!is_null($nitEmpleado) && !is_string($nitEmpleado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nitEmpleado, true), gettype($nitEmpleado)), __LINE__);
        }
        if (is_null($nitEmpleado) || (is_array($nitEmpleado) && empty($nitEmpleado))) {
            unset($this->nitEmpleado);
        } else {
            $this->nitEmpleado = $nitEmpleado;
        }
        return $this;
    }
    /**
     * Get nitEmpleador value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNitEmpleador()
    {
        return isset($this->nitEmpleador) ? $this->nitEmpleador : null;
    }
    /**
     * Set nitEmpleador value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nitEmpleador
     * @return \StructType\Response
     */
    public function setNitEmpleador($nitEmpleador = null)
    {
        // validation for constraint: string
        if (!is_null($nitEmpleador) && !is_string($nitEmpleador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nitEmpleador, true), gettype($nitEmpleador)), __LINE__);
        }
        if (is_null($nitEmpleador) || (is_array($nitEmpleador) && empty($nitEmpleador))) {
            unset($this->nitEmpleador);
        } else {
            $this->nitEmpleador = $nitEmpleador;
        }
        return $this;
    }
    /**
     * Get qr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getQr()
    {
        return isset($this->qr) ? $this->qr : null;
    }
    /**
     * Set qr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $qr
     * @return \StructType\Response
     */
    public function setQr($qr = null)
    {
        // validation for constraint: string
        if (!is_null($qr) && !is_string($qr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($qr, true), gettype($qr)), __LINE__);
        }
        if (is_null($qr) || (is_array($qr) && empty($qr))) {
            unset($this->qr);
        } else {
            $this->qr = $qr;
        }
        return $this;
    }
    /**
     * Get reglasNotificacionesDIAN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getReglasNotificacionesDIAN()
    {
        return isset($this->reglasNotificacionesDIAN) ? $this->reglasNotificacionesDIAN : null;
    }
    /**
     * Set reglasNotificacionesDIAN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $reglasNotificacionesDIAN
     * @return \StructType\Response
     */
    public function setReglasNotificacionesDIAN(\ArrayType\ArrayOfstring $reglasNotificacionesDIAN = null)
    {
        if (is_null($reglasNotificacionesDIAN) || (is_array($reglasNotificacionesDIAN) && empty($reglasNotificacionesDIAN))) {
            unset($this->reglasNotificacionesDIAN);
        } else {
            $this->reglasNotificacionesDIAN = $reglasNotificacionesDIAN;
        }
        return $this;
    }
    /**
     * Get reglasNotificacionesTFHKA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getReglasNotificacionesTFHKA()
    {
        return isset($this->reglasNotificacionesTFHKA) ? $this->reglasNotificacionesTFHKA : null;
    }
    /**
     * Set reglasNotificacionesTFHKA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $reglasNotificacionesTFHKA
     * @return \StructType\Response
     */
    public function setReglasNotificacionesTFHKA(\ArrayType\ArrayOfstring $reglasNotificacionesTFHKA = null)
    {
        if (is_null($reglasNotificacionesTFHKA) || (is_array($reglasNotificacionesTFHKA) && empty($reglasNotificacionesTFHKA))) {
            unset($this->reglasNotificacionesTFHKA);
        } else {
            $this->reglasNotificacionesTFHKA = $reglasNotificacionesTFHKA;
        }
        return $this;
    }
    /**
     * Get reglasRechazoDIAN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getReglasRechazoDIAN()
    {
        return isset($this->reglasRechazoDIAN) ? $this->reglasRechazoDIAN : null;
    }
    /**
     * Set reglasRechazoDIAN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $reglasRechazoDIAN
     * @return \StructType\Response
     */
    public function setReglasRechazoDIAN(\ArrayType\ArrayOfstring $reglasRechazoDIAN = null)
    {
        if (is_null($reglasRechazoDIAN) || (is_array($reglasRechazoDIAN) && empty($reglasRechazoDIAN))) {
            unset($this->reglasRechazoDIAN);
        } else {
            $this->reglasRechazoDIAN = $reglasRechazoDIAN;
        }
        return $this;
    }
    /**
     * Get reglasRechazoTFHKA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getReglasRechazoTFHKA()
    {
        return isset($this->reglasRechazoTFHKA) ? $this->reglasRechazoTFHKA : null;
    }
    /**
     * Set reglasRechazoTFHKA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $reglasRechazoTFHKA
     * @return \StructType\Response
     */
    public function setReglasRechazoTFHKA(\ArrayType\ArrayOfstring $reglasRechazoTFHKA = null)
    {
        if (is_null($reglasRechazoTFHKA) || (is_array($reglasRechazoTFHKA) && empty($reglasRechazoTFHKA))) {
            unset($this->reglasRechazoTFHKA);
        } else {
            $this->reglasRechazoTFHKA = $reglasRechazoTFHKA;
        }
        return $this;
    }
    /**
     * Get resultado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResultado()
    {
        return isset($this->resultado) ? $this->resultado : null;
    }
    /**
     * Set resultado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $resultado
     * @return \StructType\Response
     */
    public function setResultado($resultado = null)
    {
        // validation for constraint: string
        if (!is_null($resultado) && !is_string($resultado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resultado, true), gettype($resultado)), __LINE__);
        }
        if (is_null($resultado) || (is_array($resultado) && empty($resultado))) {
            unset($this->resultado);
        } else {
            $this->resultado = $resultado;
        }
        return $this;
    }
    /**
     * Get trackId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTrackId()
    {
        return isset($this->trackId) ? $this->trackId : null;
    }
    /**
     * Set trackId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $trackId
     * @return \StructType\Response
     */
    public function setTrackId($trackId = null)
    {
        // validation for constraint: string
        if (!is_null($trackId) && !is_string($trackId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($trackId, true), gettype($trackId)), __LINE__);
        }
        if (is_null($trackId) || (is_array($trackId) && empty($trackId))) {
            unset($this->trackId);
        } else {
            $this->trackId = $trackId;
        }
        return $this;
    }
    /**
     * Get xml value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getXml()
    {
        return isset($this->xml) ? $this->xml : null;
    }
    /**
     * Set xml value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $xml
     * @return \StructType\Response
     */
    public function setXml($xml = null)
    {
        // validation for constraint: string
        if (!is_null($xml) && !is_string($xml)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xml, true), gettype($xml)), __LINE__);
        }
        if (is_null($xml) || (is_array($xml) && empty($xml))) {
            unset($this->xml);
        } else {
            $this->xml = $xml;
        }
        return $this;
    }
}
