<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResponseDownloadDocument StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ResponseDownloadDocument
 * @subpackage Structs
 */
class ResponseDownloadDocument extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codigo;
    /**
     * The cune
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cune;
    /**
     * The documento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $documento;
    /**
     * The hash
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $hash;
    /**
     * The mensaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensaje;
    /**
     * The nombre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nombre;
    /**
     * The resultado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $resultado;
    /**
     * Constructor method for ResponseDownloadDocument
     * @uses ResponseDownloadDocument::setCodigo()
     * @uses ResponseDownloadDocument::setCune()
     * @uses ResponseDownloadDocument::setDocumento()
     * @uses ResponseDownloadDocument::setHash()
     * @uses ResponseDownloadDocument::setMensaje()
     * @uses ResponseDownloadDocument::setNombre()
     * @uses ResponseDownloadDocument::setResultado()
     * @param int $codigo
     * @param string $cune
     * @param string $documento
     * @param string $hash
     * @param string $mensaje
     * @param string $nombre
     * @param string $resultado
     */
    public function __construct($codigo = null, $cune = null, $documento = null, $hash = null, $mensaje = null, $nombre = null, $resultado = null)
    {
        $this
            ->setCodigo($codigo)
            ->setCune($cune)
            ->setDocumento($documento)
            ->setHash($hash)
            ->setMensaje($mensaje)
            ->setNombre($nombre)
            ->setResultado($resultado);
    }
    /**
     * Get codigo value
     * @return int|null
     */
    public function getCodigo()
    {
        return $this->codigo;
    }
    /**
     * Set codigo value
     * @param int $codigo
     * @return \StructType\ResponseDownloadDocument
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->codigo = $codigo;
        return $this;
    }
    /**
     * Get cune value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCune()
    {
        return isset($this->cune) ? $this->cune : null;
    }
    /**
     * Set cune value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cune
     * @return \StructType\ResponseDownloadDocument
     */
    public function setCune($cune = null)
    {
        // validation for constraint: string
        if (!is_null($cune) && !is_string($cune)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cune, true), gettype($cune)), __LINE__);
        }
        if (is_null($cune) || (is_array($cune) && empty($cune))) {
            unset($this->cune);
        } else {
            $this->cune = $cune;
        }
        return $this;
    }
    /**
     * Get documento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDocumento()
    {
        return isset($this->documento) ? $this->documento : null;
    }
    /**
     * Set documento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $documento
     * @return \StructType\ResponseDownloadDocument
     */
    public function setDocumento($documento = null)
    {
        // validation for constraint: string
        if (!is_null($documento) && !is_string($documento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documento, true), gettype($documento)), __LINE__);
        }
        if (is_null($documento) || (is_array($documento) && empty($documento))) {
            unset($this->documento);
        } else {
            $this->documento = $documento;
        }
        return $this;
    }
    /**
     * Get hash value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHash()
    {
        return isset($this->hash) ? $this->hash : null;
    }
    /**
     * Set hash value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $hash
     * @return \StructType\ResponseDownloadDocument
     */
    public function setHash($hash = null)
    {
        // validation for constraint: string
        if (!is_null($hash) && !is_string($hash)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hash, true), gettype($hash)), __LINE__);
        }
        if (is_null($hash) || (is_array($hash) && empty($hash))) {
            unset($this->hash);
        } else {
            $this->hash = $hash;
        }
        return $this;
    }
    /**
     * Get mensaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensaje()
    {
        return isset($this->mensaje) ? $this->mensaje : null;
    }
    /**
     * Set mensaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensaje
     * @return \StructType\ResponseDownloadDocument
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensaje, true), gettype($mensaje)), __LINE__);
        }
        if (is_null($mensaje) || (is_array($mensaje) && empty($mensaje))) {
            unset($this->mensaje);
        } else {
            $this->mensaje = $mensaje;
        }
        return $this;
    }
    /**
     * Get nombre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombre()
    {
        return isset($this->nombre) ? $this->nombre : null;
    }
    /**
     * Set nombre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombre
     * @return \StructType\ResponseDownloadDocument
     */
    public function setNombre($nombre = null)
    {
        // validation for constraint: string
        if (!is_null($nombre) && !is_string($nombre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombre, true), gettype($nombre)), __LINE__);
        }
        if (is_null($nombre) || (is_array($nombre) && empty($nombre))) {
            unset($this->nombre);
        } else {
            $this->nombre = $nombre;
        }
        return $this;
    }
    /**
     * Get resultado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResultado()
    {
        return isset($this->resultado) ? $this->resultado : null;
    }
    /**
     * Set resultado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $resultado
     * @return \StructType\ResponseDownloadDocument
     */
    public function setResultado($resultado = null)
    {
        // validation for constraint: string
        if (!is_null($resultado) && !is_string($resultado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resultado, true), gettype($resultado)), __LINE__);
        }
        if (is_null($resultado) || (is_array($resultado) && empty($resultado))) {
            unset($this->resultado);
        } else {
            $this->resultado = $resultado;
        }
        return $this;
    }
}
