<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResponseSendEmail StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ResponseSendEmail
 * @subpackage Structs
 */
class ResponseSendEmail extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codigo;
    /**
     * The mensaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensaje;
    /**
     * The resultado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $resultado;
    /**
     * Constructor method for ResponseSendEmail
     * @uses ResponseSendEmail::setCodigo()
     * @uses ResponseSendEmail::setMensaje()
     * @uses ResponseSendEmail::setResultado()
     * @param int $codigo
     * @param string $mensaje
     * @param string $resultado
     */
    public function __construct($codigo = null, $mensaje = null, $resultado = null)
    {
        $this
            ->setCodigo($codigo)
            ->setMensaje($mensaje)
            ->setResultado($resultado);
    }
    /**
     * Get codigo value
     * @return int|null
     */
    public function getCodigo()
    {
        return $this->codigo;
    }
    /**
     * Set codigo value
     * @param int $codigo
     * @return \StructType\ResponseSendEmail
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->codigo = $codigo;
        return $this;
    }
    /**
     * Get mensaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensaje()
    {
        return isset($this->mensaje) ? $this->mensaje : null;
    }
    /**
     * Set mensaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensaje
     * @return \StructType\ResponseSendEmail
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensaje, true), gettype($mensaje)), __LINE__);
        }
        if (is_null($mensaje) || (is_array($mensaje) && empty($mensaje))) {
            unset($this->mensaje);
        } else {
            $this->mensaje = $mensaje;
        }
        return $this;
    }
    /**
     * Get resultado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResultado()
    {
        return isset($this->resultado) ? $this->resultado : null;
    }
    /**
     * Set resultado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $resultado
     * @return \StructType\ResponseSendEmail
     */
    public function setResultado($resultado = null)
    {
        // validation for constraint: string
        if (!is_null($resultado) && !is_string($resultado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resultado, true), gettype($resultado)), __LINE__);
        }
        if (is_null($resultado) || (is_array($resultado) && empty($resultado))) {
            unset($this->resultado);
        } else {
            $this->resultado = $resultado;
        }
        return $this;
    }
}
