<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Transporte StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Transporte
 * @subpackage Structs
 */
class Transporte extends AbstractStructBase
{
    /**
     * The auxilioTransporte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $auxilioTransporte;
    /**
     * The extrasNom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExtensibleNom
     */
    public $extrasNom;
    /**
     * The viaticoManuAlojNS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $viaticoManuAlojNS;
    /**
     * The viaticoManuAlojS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $viaticoManuAlojS;
    /**
     * Constructor method for Transporte
     * @uses Transporte::setAuxilioTransporte()
     * @uses Transporte::setExtrasNom()
     * @uses Transporte::setViaticoManuAlojNS()
     * @uses Transporte::setViaticoManuAlojS()
     * @param string $auxilioTransporte
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @param string $viaticoManuAlojNS
     * @param string $viaticoManuAlojS
     */
    public function __construct($auxilioTransporte = null, \ArrayType\ArrayOfExtensibleNom $extrasNom = null, $viaticoManuAlojNS = null, $viaticoManuAlojS = null)
    {
        $this
            ->setAuxilioTransporte($auxilioTransporte)
            ->setExtrasNom($extrasNom)
            ->setViaticoManuAlojNS($viaticoManuAlojNS)
            ->setViaticoManuAlojS($viaticoManuAlojS);
    }
    /**
     * Get auxilioTransporte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAuxilioTransporte()
    {
        return isset($this->auxilioTransporte) ? $this->auxilioTransporte : null;
    }
    /**
     * Set auxilioTransporte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $auxilioTransporte
     * @return \StructType\Transporte
     */
    public function setAuxilioTransporte($auxilioTransporte = null)
    {
        // validation for constraint: string
        if (!is_null($auxilioTransporte) && !is_string($auxilioTransporte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($auxilioTransporte, true), gettype($auxilioTransporte)), __LINE__);
        }
        if (is_null($auxilioTransporte) || (is_array($auxilioTransporte) && empty($auxilioTransporte))) {
            unset($this->auxilioTransporte);
        } else {
            $this->auxilioTransporte = $auxilioTransporte;
        }
        return $this;
    }
    /**
     * Get extrasNom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExtensibleNom|null
     */
    public function getExtrasNom()
    {
        return isset($this->extrasNom) ? $this->extrasNom : null;
    }
    /**
     * Set extrasNom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExtensibleNom $extrasNom
     * @return \StructType\Transporte
     */
    public function setExtrasNom(\ArrayType\ArrayOfExtensibleNom $extrasNom = null)
    {
        if (is_null($extrasNom) || (is_array($extrasNom) && empty($extrasNom))) {
            unset($this->extrasNom);
        } else {
            $this->extrasNom = $extrasNom;
        }
        return $this;
    }
    /**
     * Get viaticoManuAlojNS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getViaticoManuAlojNS()
    {
        return isset($this->viaticoManuAlojNS) ? $this->viaticoManuAlojNS : null;
    }
    /**
     * Set viaticoManuAlojNS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $viaticoManuAlojNS
     * @return \StructType\Transporte
     */
    public function setViaticoManuAlojNS($viaticoManuAlojNS = null)
    {
        // validation for constraint: string
        if (!is_null($viaticoManuAlojNS) && !is_string($viaticoManuAlojNS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($viaticoManuAlojNS, true), gettype($viaticoManuAlojNS)), __LINE__);
        }
        if (is_null($viaticoManuAlojNS) || (is_array($viaticoManuAlojNS) && empty($viaticoManuAlojNS))) {
            unset($this->viaticoManuAlojNS);
        } else {
            $this->viaticoManuAlojNS = $viaticoManuAlojNS;
        }
        return $this;
    }
    /**
     * Get viaticoManuAlojS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getViaticoManuAlojS()
    {
        return isset($this->viaticoManuAlojS) ? $this->viaticoManuAlojS : null;
    }
    /**
     * Set viaticoManuAlojS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $viaticoManuAlojS
     * @return \StructType\Transporte
     */
    public function setViaticoManuAlojS($viaticoManuAlojS = null)
    {
        // validation for constraint: string
        if (!is_null($viaticoManuAlojS) && !is_string($viaticoManuAlojS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($viaticoManuAlojS, true), gettype($viaticoManuAlojS)), __LINE__);
        }
        if (is_null($viaticoManuAlojS) || (is_array($viaticoManuAlojS) && empty($viaticoManuAlojS))) {
            unset($this->viaticoManuAlojS);
        } else {
            $this->viaticoManuAlojS = $viaticoManuAlojS;
        }
        return $this;
    }
}
